/*
 * CListWind - director and pane
 *
 * 	SUPERCLASS = CDirector
 *
 */
 
#define _H_CListWind

#include <CDirector.h>					/* Interface for its superclass		*/
#include <CPane.h>
#include "bits.h"

struct CLList : CPane {
	ListHandle listH;
	int			nrows;

	void		ILList(CView *anEnclosure, CBureaucrat *aSupervisor,
							short aWidth, short aHeight,
							short aHEncl, short aVEncl,
							SizingOption aHSizing, SizingOption aVSizing);
	void		Dispose(void);

	void		Activate(void);
	void		Deactivate(void);

									/** Drawing **/
	void		Draw(Rect *area);

									/** Mouse **/
	void		DoClick(Point hitPt, short modifierKeys, long when);
	void 		DoKeyDown(char theChar,Byte keyCode, EventRecord *macEvent);

	bitmap_t * 	GetSelect(long len);

	void		ChangeSize(Rect *delta, Boolean redraw);
	
	void		AddLine(char *line);
	void		DelLine(int line, int count);
	void		SetLine(int line, char *txt);
	void		SelectLine(int line);
};

struct CListWind : CDirector {			/* Class Declaration				*/
								/** Instance Variables **/
	CLList		*itsPane;				/* Pane for displaying contents		*/
	
	void		IListWind(int windresid, char *title, int width, int length);
	void		Dispose(void);

	void		DoCommand(long theCommand);
	void		UpdateMenus(void);
	
	void		ClickLine(int line);
	void		Enab(Boolean enab);
	void		TmpMsg(char *msg);
};
