#define	R_Exec			 'MWSX'	/*resource type of exec modules*/

/*control codes passed to exec module*/
#define	xCtlIdle		 0	/*called from ProgIdle*/
#define	xCtlSend		 1	/*called from ProgSend    before TL_Send*/
#define	xCtlReceive		 2	/*called from ProgReceive before TL_Receive*/
#define	xCtlFilter		 3	/*called from ProgReceive after  TL_Receive*/
#define	xCtlInvoke		 4	/*start code module*/
#define	xCtlUnload		 5	/*terminate code module*/
#define	xCtlCommand		 6	/*data from host*/
#define	xCtlActivate	 7	/*activate exec window*/
#define	xCtlDraw		 8	/*update exec window*/
#define	xCtlKey			 9	/*keydown*/
#define	xCtlMouse		10	/*mousedown in exec window*/
#define	xCtlKill		11	/*system closing exec window*/
#define	xCtlDismiss		12	/*user closing exec window*/
#define	xCtlStdMenuEvt 	13	/*user selected from standard menu*/

/*mws routine table indexes*/
#define	mwsCommand		 0
#define	mwsSend			 1
#define	mwsReceive		 2
#define	mwsGetAlias		 3

/*windowKind for windows created by an exec module*/
#define	wExec			 11
	
/*option bits*/
#define	xCallIdle		 0x0001	/*call during Idle loop*/
#define	xCallKey		 0x0002	/*call on each key press*/
#define	xCallSend		 0x0004	/*call prior to sending a message*/
#define	xCallReceive	 0x0008	/*call prior to receiving a message*/
#define	xCallFilter		 0x0010	/*call after receiving a messge*/
#define	xCallMouse		 0x0020	/*call on each mouse down*/
#define	xCallStdMenuEvt	 0x0040	/*call on each standard menu selection*/

typedef EventRecord *xEventPtr;

typedef ProcPtr	rtTable[mwsGetAlias+1],*rtTable_pt;

	/*Data structure passed to exec modules in ctl calls. Any windows*/
	/*created by an exec module should be windowKind = wExec & have*/
	/*a handle to this data structure in their window refcon field*/

#define PASCAL_BOOLEAN char
struct TRExecRef {
	long xAlias;				/*alias of exec module*/
	Handle xExec;				/*handle to exec module*/
	long xStorage;				/*private storage for module*/
	long xOptions;				/*option bits*/
	long xReserve;				/*reserved for future use*/
	WindowPtr xWindow;			/*window pointer*/
	xEventPtr xEvent;			/*Current event*/
	PASCAL_BOOLEAN xActive;		/*TRUE if activating window*/
	PASCAL_BOOLEAN xMWSReserve;	/*reserved for MWS use*/
	short xKey;					/*Current character*/
	PASCAL_BOOLEAN xShift;		/*TRUE if shift key depressed*/
	PASCAL_BOOLEAN xDouble;		/*TRUE if double-click*/
	Point xMousePt;				/*Point of mouse click*/
	TPMsg xMsg;					/*current MWS message*/
	rtTable xMWSTable;			/*table of mws routines*/
	short xMenuAlias;			/*alias of menu bar*/
	short xMenuMenu;			/*number of standard menu*/
	short xMenuItem;			/*item of standard menu*/
};
typedef struct TRExecRef TRExecRef,*TPExecRef;
typedef TPExecRef *THExecRef;
	
struct TRAlias {
	short aliasType;	/*1=dialog, 2=window, 3=file, 4=exec, 5=menu*/
	long alias;	/*alias in, window pointer out*/
};
typedef struct TRAlias *TPAlias;
typedef TPAlias *THAlias;

/*call backs to MacWorkStation*/
void MWS_Command(TPMsg theMsg,THExecRef execRef);
void MWS_Send(TPMsg theMsg,THExecRef execRef);
void MWS_Receive(TPMsg theMsg,THExecRef execRef);
void MWS_GetAlias(TPAlias theMsg,THExecRef execRef);

#define proper_a4 main
extern void main(void);

/* user supplied exec code entry point*/
extern pascal void exec_main(short xecCode,THExecRef xecRef);
