/*
	MWS_TLPM.h -- Defines and Types for MacWorkStation Transport Layer

	version:			3.0
	last modified:		9-dec-87

	C Interface to the MacWorkStation Transport Layer
	Copyright Apple Computer,Inc. 1987
	All rights reserved.
*/

#ifndef __MWS_TLPM__
#define __MWS_TLPM__

#ifdef XXXX_YYY
#include <Types.h>
#endif

#define eNoProtocol		1			/* error if TLPM not found */
#define tlResType		'MWST'		/* resource type for TLPM's */

#define tlOpen			1			/* control codes for TLPM's */
#define tlClose			2
#define tlRead			3
#define tlWrite			4

	/* array indexes into TRTLParms for AppleTalk protocols */

#define cNameStrID		1		/* id of STR# resource containing names */
#define cHostFlag		9		/* 0=User, 1=Host */

	/* STR# indexes for AppleTalk NBP */

#define cUserName		1		/* index of User name */
#define cUserType		2		/* index of User type */
#define cUserZone		3		/* index of User zone */
#define cHostName		4		/* index of Host name */
#define cHostType		5		/* index of Host type */
#define cHostZone		6		/* index of Host zone */

	/* array indexes into TRTLParms for serial protocols */

#define cIOPort			0
#define cBaudRate		1
#define cParity			2
#define cDataBits		3
#define cStopBits		4
#define cXonXoff		5		/*0=None, 1=Input, 2=Output, 3=Both*/
#define cXonChar		6
#define cXoffChar		7
#define cMsgBegChar		8
#define cMsgEndChar		9
	
	/* Mask to test for Xon/Xoff reset */

#define cXInput			1
#define cXOutput		2

typedef struct {
	long 		param[10];	/* parameters needed to open 	*/
} TRTLParms, *TPTLParms;

typedef struct {
	Handle		pmStorage;	/* Handle to local storage		*/
	Ptr			dataPtr;	/* Pointer to data				*/
	long		reqCount;	/* Max bytes to read/write		*/
	long		actCount;	/* Actual bytes read/written	*/
	Boolean		msgValid;	/* True if valid MWS message	*/
	char		sessionID;	/* (will be session ID)			*/
	TRTLParms	param;		/* Copy of parameters from open	*/
} PMParamBlk, *PMParamPtr;

#endif __MWS_TLPM__

/* End of MWS_TLPM.h */
