/*
** This is the TDoc class definition.  This class is an adaptation of 
** the class of the same name in the book, Elements of C++ Macintosh 
** Programming, by Dan Weston.
**
** Copyright  1991 Mark Gross 
** (RR2, Box 84, Clayville, NY 13322); 		
** this file may be published everywhere, but no charge
** may be made for its use.  Please contact me about any bugs found.
** I'm also looking for Macintosh development work, so drop me a line
** if you think I could help.  
**
** If you're trying to learn Macintosh programming, then this
** file will not be of much value.
** DON'T READ THIS FILE!!!  You'll go blind if you do.  
** Look only at the class declaration file (that's the .h file).  
** The only thing you need to know is that it works (as far as 
** I know). It isn't commented; for comments read Dan Weston's book.
** See also Macintosh Programming Primer, vol I & II
** Inside Macintosh I-VI, THINK Reference, THINK C User's Manual, and
** Tech notes.
*/

#include "TDoc.h"
#include "magics.h"


TDoc*		TDoc::Init(OSType theCreator, SFReply *SFInfo)
{
	fCreator = theCreator;
	fNeedtoSave = false;
	fDocWindow = NULL;
	fRefNum = 0;
	fFileOpen = false;
	
	if (SFInfo != NULL)
	{
		fNeedtoSaveAs = false;
		fFileInfo = *SFInfo;
	}
	else
	{
		fNeedtoSaveAs = true;
		fFileInfo.good = false;
	}/*end if else*/
	return this;
		
}/*end of member function Init */

void	TDoc::Delete( void)
{
	if (fDocWindow != NULL)
	{
		DisposeWindow( fDocWindow);
		fDocWindow = NULL;
	}
}/*end of member function Destroy */


Boolean		TDoc::MakeWindow(Boolean colorWindow)
{
	if(colorWindow)
/*		fDocWindow = GetNewCWindow(GetWinID(), NULL, -1L);*/
		fDocWindow = GetNewWindow(GetWinID(), NULL, -1L);
	else
		fDocWindow = GetNewWindow(GetWinID(), NULL, -1L);
	return (fDocWindow != NULL);
}/*end of MakeWinodw member function*/


short	TDoc::GetWinID(void)
{
	return  	rGenericDoc;
}/* end of utillity function get WinID*/


Boolean		TDoc::InitDoc(void)
{
	return	true;
}/*end of InitDoc member function*/



WindowPtr	TDoc::GetDocWindow(void)
{
	return fDocWindow;
}/*end of get doc window member function*/



void		TDoc::SetDocWindowTitle(Str255 title)
{
	if(fDocWindow) SetWTitle(fDocWindow, title);
}/*end set doc window title member function*/



void		TDoc::MoveDocWindow(short h, short v)
{
	if(fDocWindow) MoveWindow(fDocWindow, h, v, TRUE);
}/*end move doc window member fucntion*/


void		TDoc::ShowDocWindow(void)
{
	if(fDocWindow) ShowWindow(fDocWindow);
}/*end show doc window member function*/


void		TDoc::DoTheUpdate(EventRecord *theEvent)
{
	Rect 	r;
	
	if(fDocWindow != NULL)
	{
		SetPort(fDocWindow);
		BeginUpdate(fDocWindow);
		r = (**(fDocWindow->visRgn)).rgnBBox;
		Draw(&r);
		DrawGrowIcon(fDocWindow);
		EndUpdate(fDocWindow);
	}/*end if*/
}/*end Do the update member function*/

void		TDoc::Draw(Rect *r)
{
	EraseRect(r);
	/*this baby will be overridden*/
}/*end of Draw member function*/


void		TDoc::DoActivate(EventRecord *theEvent)
{
	Boolean	activating;
	
	activating = theEvent->modifiers & activeFlag;
	if (fDocWindow == NULL) return;
	
	SetPort(fDocWindow);
	DrawGrowIcon(fDocWindow);
	if(activating)
		Activate();
	else
		Deactivate();
}/*end of do activate member fuction*/


void		TDoc::Activate(void)
{
/* over ride me*/
}

void		TDoc::Deactivate(void)
{
/*over ride me too*/
}


void		TDoc::DoGrow(EventRecord *theEvent)
{
	long		result;
	RgnHandle	theGrayRgn;
	Rect		r;
	
	theGrayRgn = GetGrayRgn();
	r = (**theGrayRgn).rgnBBox;
	r.top = MINHIGHT; r.left = MINWIDTH;
	SetPort(fDocWindow);
	result = GrowWindow(fDocWindow, theEvent->where, &r);
	
	if(result != 0)
	{
		r = fDocWindow->portRect;
		r.left = r.right - kScrollBarPos;
		InvalRect(&r);
		r = fDocWindow->portRect;
		r.top = r.bottom - kScrollBarPos;
		InvalRect(&r);
		
		SizeWindow(fDocWindow, LoWord(result), HiWord(result), TRUE);
		
		r = fDocWindow->portRect;
		r.left = r.right - kScrollBarPos;
		InvalRect(&r);
		r = fDocWindow->portRect;
		r.top = r.bottom - kScrollBarPos;
		InvalRect(&r);
	}/*end if */
}/*end of DoGrow member function*/


void		TDoc::DoZoom(short partCode)
{	
	if(fDocWindow) 
	{
		SetPort(fDocWindow);
		EraseRect(&fDocWindow->portRect);
		ZoomWindow(fDocWindow, partCode, fDocWindow == FrontWindow());
		
		InvalRect(&fDocWindow->portRect);
	}/*end if*/
}/*end do zoom member function*/


void		TDoc::DoDrag(EventRecord *theEvent)
{
	RgnHandle	theGrayRgn;
	Rect		r;
	
	theGrayRgn = GetGrayRgn();
	r = (**theGrayRgn).rgnBBox;
	
	if(fDocWindow)
		DragWindow(fDocWindow, theEvent->where, &r);

}/*end do drag member function*/


void		TDoc::DoContent(EventRecord *theEvent)
{

/*over ride this baby!!*/

}/*end of do content click member function*/

	

void		TDoc::DoKeyDown(EventRecord *theEvent)
{

/*over ride this baby!!*/

}/*end of do key down member function*/


void		TDoc::DoIdle(void)
{

/*over ride this baby!!*/

}/*end of do idle member function*/



void		TDoc::AdjustCursor(Point where)
{

/*over ride this baby!!*/

}/*end of adjuct cursor member function*/


void		TDoc::AdjustDocMenus(void)
{
	MenuHandle	menu;
	
	menu = GetMHandle(rFileMenu);
	SetMenuAbility(menu, iClose, CanClose() );
	SetMenuAbility(menu, iSave, CanSave() );
	SetMenuAbility(menu, iSaveAs, CanSaveAs() );
	SetMenuAbility(menu, iPageSetup, CanPageSetup() );
	SetMenuAbility(menu, iPrint, CanPrint() );
	
	menu = GetMHandle(rEdit);
	SetMenuAbility(menu, iUndo, CanUndo() );
	SetMenuAbility(menu, iCut, HaveSelection() );
	SetMenuAbility(menu, iCopy, HaveSelection() );
	SetMenuAbility(menu, iClear, HaveSelection() );
	SetMenuAbility(menu, iSelectAll, CanSelectAll() );
	
}/*end of adjust doc menu member function*/




void		TDoc::SetMenuAbility(MenuHandle menu, short item, Boolean enable)
{

	if (enable) 
		EnableItem(menu, item);
	else
		DisableItem(menu, item);
	
}/*end set menu ability member function*/

/*bug in compiler!!!!
void		TDoc::SetMenuAbility(MenuHandle menu, short item, Boolean enable)
{

	enable ? EnableItem(menu, item) : DisableItem(menu, item);
	
}/*end set menu ability member function*/



Boolean 	TDoc::CanUndo(void)
{
	return false;
}

Boolean		TDoc::CanSave(void)
{
	return fNeedtoSave;
}

Boolean		TDoc::CanPaste(OSType t)
{
	return false;
}


Boolean		TDoc::CanClose(void)
{
	return TRUE;
}

Boolean		TDoc::CanSaveAs(void)
{
	return false;
}

Boolean		TDoc::CanPageSetup(void)
{
	return false;
}

Boolean		TDoc::CanPrint(void)
{
	return false;
}


Boolean		TDoc::HaveSelection(void)
{
	return false;
}

Boolean		TDoc::CanSelectAll(void)
{
	return false;
}

Boolean		TDoc::DoDocMenuCommand(short menuID, short menuItem)
{
	switch(menuID)
	{
		case rFileMenu:
			switch(menuItem)
			{
				case iSave:
					DoSave();
					break;
				
				case iSaveAs:
					DoSaveAs();
					break;
					
				case iPageSetup:
					DoPageSetup();
					break;
				
				case iPrint:
					DoPrint();
					break;
					
				default:
					return false;
			}/*end of inner switch*/
			return TRUE;
			break;
			
		case rEdit:
			if(!SystemEdit(menuItem-1) )
			{
				switch(menuItem)
				{
					case iClear:
						DoClear();
						break;
						
					case iSelectAll:
						DoSelectAll();
						break;
						
					default:
						return false;
				}/*end inner switch*/
				return TRUE;
			}
			else
			{
				return TRUE;
			}/*end if then else*/
	}/* end outer switch on menu id*/
	
	return false;
}/*end of do doc menu command*/


void	TDoc::DoClear(void)
{
/*over ride this*/
}


void	TDoc::DoSelectAll(void)
{
/*over ride this*/
}


Boolean		TDoc::DoCut(Handle *theData, OSType *theType)
{
	*theData =  NULL;
	*theType = '????';
	return false;
}/*end of do cut member function*/


Boolean		TDoc::DoCopy(Handle *theData, OSType *theType)
{
	*theData =  NULL;
	*theType = '????';
	return false;
}/*end of do copy member function*/


void		TDoc::DoPaste(Handle theData, OSType *theType)
{
/*over ride this*/
}


void		TDoc::DoUndo(void)
{
/*over ride this*/
}



short		TDoc::OpenDocFile(SFReply *reply)
{
	short	refnum;
	OSErr	err;
	
	err = FSOpen(reply->fName, reply->vRefNum, &refnum);
	switch(err)
	{
		case fnfErr: /*file not found*/
			err = Create(reply->fName, reply->vRefNum, 
					fCreator, GetDocType());
			if(err ==noErr)
			{
				err = FSOpen(reply->fName, reply->vRefNum, &refnum);
				if(err != noErr)
					return 0;
			}
			else
			{
				return 0;
			}/*end if then else*/
			/* no break */
			
		case noErr:		/* file opened ok*/
			fFileOpen = TRUE;
			fRefNum = refnum;
			return refnum;
			break;
			
		case opWrErr:
			ErrorAlert(rDocErrorStrings, sFileOpen);
			return 0;
			break;
			
		default:
			ErrorAlert(rDocErrorStrings, sUnknownErr);
			return 0;
	}/*end of switch*/
}/*end of open doc file member function*/


void		TDoc::CloseDocFile(short refNum)
{
	OSErr err;
	
	err = FSClose(refNum);
}/*end close doc file member function*/


Boolean		TDoc::ReadDocFile(short refNum)
{
	return TRUE;
	
}/*end of read doc file member function*/

Boolean		TDoc::WriteDocFile(short refNum)
{
	return TRUE;
	
}/*end of write doc file member function*/

Boolean		TDoc::DoSaveAs(void)
{
	SFReply	whereToSave;
	Point	p;
	Str255	title;
	
	GetWTitle(fDocWindow, title);
	
	p.h = 100; p.v = 100;
	SFPutFile(p, "\pSave file as...", title, NULL, &whereToSave);
	
	if( !whereToSave.good)
	{
		return false;
	}
	else
	{
		fFileInfo = whereToSave;
		fRefNum = OpenDocFile( &whereToSave);
		if(fRefNum == 0)
		{
			return false;
		}
		else
		{
			fFileOpen = true;
			if(!WriteDocFile(fRefNum) )
			{
				return false;
			}
			else
			{
				fNeedtoSave = false;
				fNeedtoSaveAs = false;
				SetDocWindowTitle(whereToSave.fName);
			}/*end inner most if then else*/
		}/*end midle if then else*/
	}/*end outer if the else*/
	
	return TRUE; /*finaly passed all tests for doing save as*/
}/*end of do save as member function*/

	
Boolean		TDoc::DoSave(void)
{
	if(fNeedtoSaveAs)
		return DoSaveAs();
		
	if(WriteDocFile(fRefNum) )
	{
		fNeedtoSave = false;
		fNeedtoSaveAs = false;
		return TRUE;
	}
	else
	{
		return false;
	}/*end if then else*/
}/*end do save member function*/


short		TDoc::WantToSave(void)
{
	Str255	title;
	Str255	nullStr;
	
	*nullStr = 0;
	
	if(fDocWindow)
	{
		GetWTitle(fDocWindow, title);
		ParamText(title, nullStr, nullStr, nullStr);
	}
	else
	{
		ParamText(nullStr,nullStr,nullStr,nullStr);
	}/*end if then else*/
	
	return Alert(rWantToSave, NULL);
}/*end of want to save member function*/

Boolean		TDoc::DoClose(void)
{
	short saveit;
	
	if(fNeedtoSave)
	{
		saveit = WantToSave();
		if(saveit == iCancel)
			return false;
		
		if(saveit == iYes)
		{
			if(!DoSave() )
				return false;
		}/*end if*/
	}/*end if*/
	
	if(fFileOpen )
		CloseDocFile(fRefNum);
	
	return TRUE;
}/*end do close member fuction*/


OSType		TDoc::GetDocType(void)
{
	return '????';
	
}/*end get doc type member function*/


void		TDoc::DoPageSetup(void)
{
/*over ride this*/
}

void		TDoc::DoPrint(void)
{
/*over ride this*/
}

void		TDoc::ErrorAlert(short stringsID, short theError)
{
	short	result;
	Str255	theStr;
	Str255	nullStr;
	
	*nullStr = 0;
	
	GetIndString(theStr, stringsID, theError);
	
	ParamText(theStr, nullStr, nullStr, nullStr);
	result = CautionAlert(rErrorAlert, NULL);
}/*end of error alert member function*/


