/*
** This is the TList class definition.  This class is an adaptation of 
** the class of the same name in the book, Elements of C++ Macintosh 
** Programming, by Dan Weston.
**
** Copyright  1991 Mark Gross 
** (RR2, Box 84, Clayville, NY 13322); 		
** this file may be published everywhere, but no charge
** may be made for its use.  Please contact me about any bugs found.
** I'm also looking for Macintosh development work, so drop me a line
** if you think I could help.  
*/

#include "TList.h"
#include <oops.h>
#define		NULL 0L

	
TList*	TList::Init(void)
{
	fLink = NULL;
	fNumItems = 0;
	return this;
}

void	TList::AddItem(void* item)
{
	fLink = ((TLink *) new(TLink))->Init(fLink, item);
	fNumItems++;
}

void	TList::RemoveItem(void* item)
{
	TLink  *temp, *last;
	
	last = NULL;
	
	for(temp = fLink; temp!=NULL; temp = temp->GetNext() )
	{	if(temp->GetItem() == item)
		{
			if(last==NULL)
				fLink = temp->GetNext();
			else
				last->SetNext(temp->GetNext());
			
			delete(temp);
			fNumItems--;
			return;
		}
		else
			last = temp;
		
	}
}

int		TList::NumItems(void)
{
	return fNumItems;
}

TDoc*	TList::FindDoc(WindowPtr window)
{
	TLink* temp;
	TDoc*	tDoc;
	
	for (temp = fLink; temp!=NULL; temp=temp->GetNext() )
	{
		tDoc = (TDoc*)temp->GetItem();
		if (tDoc->GetDocWindow() == window)
			return tDoc;
	}
	return NULL;
}

