/*
 *--- CMIDIInputPort.h --------------------------------------------------------
 * Copyright  Paul Ferguson, 1990, 1991, 1992.  All rights reserved.
 *
 * For use with THINK C 5.0 and the THINK Class Library.
 *
 * Description:
 *	This class defines a MIDI Manager Input port object.
 *
 *	Refer to the CMIDI Programmer's Manual for a complete desciption of
 *	this class.
 *----------------------------------------------------------------------------
 */
#pragma once
#include "CMIDIDataPort.h"
#include "CMIDITimePort.h"

class CMIDIInputPort : public CMIDIDataPort
{
public:

	OSErr 	IMIDIInputPort(
				StringPtr		theName, 		// Pascal format, 31 char max
				OSType			thePortID,
				Boolean			theVisibleFlag,
				CMIDITimePort *	theTimePort,
				long			theOffset,		// Current, nothing, everything
				short			theBufSize,
				ProcPtr			theReadHook);
	ProcPtr	GetReadHook(void);
	void	SetReadHook(ProcPtr theReadHook);
	void	Flush(void);
	void	Poll(long offsetTime);
	void	DiscardPacket(MIDIPacketPtr thePacket);

private:

	static pascal void	(*midiDiscardProc) (short theRefNum, MIDIPacketPtr thePacket);
	static pascal void	(*midiPollProc) (short theRefNum, long theOffsetTime);
	static pascal void	(*midiFlushProc) (short theRefNum);
};

// end of CMIDIInputPort.h