/*
 *--- CMIDIOutputPort.h -------------------------------------------------------
 * Copyright  Paul Ferguson, 1990, 1991, 1992.  All rights reserved.
 *
 *	For use with THINK C 5.0 and the THINK Class Library.
 *
 * Description:
 *	This class defines a MIDI Manager output port object.
 *
 *	Refer to the CMIDI Programmer's Manual for a complete desciption of
 *	this class.
 *----------------------------------------------------------------------------
 */
#pragma once
#include "CMIDIDataPort.h"
#include "CMIDITimePort.h"


class CMIDIOutputPort : public CMIDIDataPort
{

public:

	OSErr			IMIDIOutputPort(
						StringPtr		theName, 		// Pascal format, 31 char max
						OSType			thePortID,
						Boolean			theVisibleFlag,
						CMIDITimePort *	theTimePort,
						long			theOffset);
	virtual	OSErr	WritePacket(MIDIPacketPtr theMIDIPacket);
	virtual	OSErr	Write(char * theData, short theDataLen);
	virtual	OSErr	WriteTS(
						char *			theData,
						short			theDataLen,
						long			theTimeStamp);

private:

	OSErr			DoMIDIWrite(
						char *			theData,
						short			theDataLen,
						unsigned char	theFlags,
						long			theTimeStamp);
	static pascal OSErr	(*midiWriteProc) (short refnum, MIDIPacketPtr packet);
};

// end of CMIDIOutputPort.h