/******************************************************************************
 myMenus.c
					Menu Handlers for sample application
								
		Copyright 1988 Gregory H. Dow.  All Rights Reserved.
		
*******************************************************************************/

#include "Common.h"
#include "GlobalVars.h"
#include "CWindow.h"
#include "CMenu.h"
#include "CView.h"
#include "CScrollView.h"
#include "CStatTextV.h"
#include "CItemPalV.h"
#include "CCharPalette.h"
#include "CTearMenu.h"

void	DoDemoFilter();
void	DoDemoModeless();

ObjectH		conView;

/******************************************************************************
 DoTestMenu
 
 		The Test Menu (used for testing new features)
 ******************************************************************************/

void	DoTestMenu(theItem)
short		theItem;					/* Index number of item selected	*/
{
	ObjectH		windObject;
	ObjectH		group;
	ObjectH		theView;
	Rect		theRect;
	Handle		theHand;

	switch (theItem) {
	
		case 1:
			SetRect(&theRect, 0, 0, 500, 300);
			theView = NewObject(sizeof(ViewObj), ViewDispatcher);
			SendMsg(theView, msgINITobj, &theRect);
			
			windObject = NewObject(sizeof(WindowObj), WindowDispatcher);
			SendMsg(windObject, msgINITobj, NULL, 20000, wpSTANDARD);
			SendMsg(windObject, msgADDVIEWwind, theView);
			ShowWindowFW(windObject);
			break;
			
		case 2:
			SetRect(&theRect, 0, 0, 400, 200);
			theView = NewObject(sizeof(ScrollViewObj), ScrollViewDispatcher);
			SendMsg(theView, msgINITobj, &theRect, TRUE, TRUE);
			
			windObject = NewObject(sizeof(WindowObj), WindowDispatcher);
			SendMsg(windObject, msgINITobj, NULL, 20000, wpSTANDARD);
			SendMsg(windObject, msgADDVIEWwind, theView);
			ShowWindowFW(windObject);
			break;
			
		case 3:
			SetRect(&theRect, 0, 0, 500, 300);
			theView = NewObject(sizeof(ViewObj), ViewDispatcher);
			SendMsg(theView, msgINITobj, &theRect);
			
			windObject = NewObject(sizeof(WindowObj), WindowDispatcher);
			SendMsg(windObject, msgINITobj, NULL, 20010, wpFLOATING+wpPERMANENT);
			SendMsg(windObject, msgADDVIEWwind, theView);
			ShowWindowFW(windObject);
			break;
			
		case 4:
			SendMsg(gDebugger, msgLEVELdbug, 1 - gDebugLevel);
			break;
			
		case 5:
			theView = NewObject(sizeof(ItemPalVObj), ItemPalVDispatcher);
			SendMsg(theView, msgINITobj, 500, CharPaletteDispatcher);
			
			windObject = NewObject(sizeof(WindowObj), WindowDispatcher);
			SendMsg(windObject, msgINITobj, NULL, 20010,
						wpFLOATING+wpPERMANENT+wpMOUSEACT);
			SendMsg(windObject, msgADDVIEWwind, theView);
			ShowWindowFW(windObject);
			break;
			
		case 6:
			break;
			
		case 7:
			break;
			
		case 8:
			break;
			
		case 9:
			break;
	}
}


/******************************************************************************
 DoPaletteMenu
 
 		The Palette Menu
 ******************************************************************************/

void	DoPaletteMenu(theItem, menuID)
short		theItem;
short		menuID;
{
	MenuHandle			theMenu;
	ItemPaletteObjH		thePalette;
	
	theMenu = GetMHandle(menuID);
	thePalette = (ItemPaletteObjH)
					GetResource(IPALRESTYPE, HiWord((**theMenu).enableFlags));
	SendMsg(thePalette, msgSELECTipal, theItem);
}


/******************************************************************************
 SetUpMyMenus
 
 		Install menus for my application in the menu bar
 ******************************************************************************/
 
void	SetUpMyMenus()
{	
	MakeStdAppleMenu();					/* The Apple Menu					*/
	MakeStdFileMenu();					/* The File Menu					*/
	MakeStdEditMenu();					/* The Edit Menu					*/

										/* The Test Menu					*/
	SendMsg(NewObject(sizeof(MenuObj), MenuDispatcher),
				msgINITobj, 131, 0, DoTestMenu);
										/* Palette Menu						*/
	SendMsg(NewResObject('Tear', 500, TearMenuDispatcher),
				msgINITobj, 500, 500, 500, CharPaletteDispatcher);
}
