#pragma once

#define MAXCOL			80		/* Maximum columns in a window */
#define MAXWIN			20		/* Maximum of windows we allow. We allocate memory
										for the windows at startup to avoid heap
										fragmentation */

#define RES_MARGIN	4		/* left and right text margin in result windows */
#define ENTRY_MARGIN	4		/* left and right text margin in entry windows */
#define MIN_LINES		4		/* minimum number of lines in window contents area */

extern Rect	gDragRect, 		/* Max drag area */
				gEntryWinRect, /* size of entry window */
				gResWinRect,  	/* size of result window */
				gQueryWinRect,	/* size of query window */
				gMinRect;		/* minimum and maximum size of res and entry window */

extern WDRec		gWindows[MAXWIN];
extern WindowPtr	gWindowsMenu[MAXWIN];			/* For handling of Windows menu		*/

/* window.c */
void InvalBars(WindowPtr wPtr);
void ClearWindowRec(WDPtr wdp);
void PrepWindows(void);
void AdjustPosition(short w, Rect *rect);
WDPtr FindMyWindow(WindowPtr wPtr);
short GetFreeWindow(void);
void DoGrow(WindowPtr wPtr, Point where);
void GrowScroll(WDPtr wdp);
void DoZoom(WindowPtr wPtr, short partCode);
Boolean CloseMyWindow(WDPtr wdp, Boolean shift);
Boolean CloseAllWindows(Boolean shift);
void SetVScroll(WDPtr wdp);
void SetHScroll(WDPtr wdp);
void AdjustWSize(short wKind, Rect *r, short height, short width);
void DoDrawGrowIcon(WindowPtr wPtr);
void GetViewRect(WindowPtr wPtr, Rect *r);
void AddWindowToMenu(StringPtr name, WindowPtr wPtr);
void DelWindowFromMenu(WindowPtr wPtr);