/*
 * JADG.h
 *
 * Jamie's After Dark Glue
 *
 * JADG.c and JADG.h are in the public domain.
 *
 */


/******************************/

#pragma once

/******************************/

#include <QuickDraw.h>
#include <GraphicsModule_Types.h>

/******************************/

typedef OSErr (jadgFunc)(					\
	Handle *storage,							\
	RgnHandle blankRgn,						\
	short message,								\
	GMParamBlockPtr params					\
	);

/******************************/


	/*
	 * The following eight functions need to be written.  They're
	 * declared extern here, so the compiler trusts that they exist
	 * somewhere.  If they don't, the linker will not be happy.
	 */
	
extern jadgFunc doInitialize;
extern jadgFunc doClose;
extern jadgFunc doBlank;
extern jadgFunc doDrawFrame;
extern jadgFunc doModuleSelected;
extern jadgFunc doAbout;
extern jadgFunc doButtonMessage;
extern void setADErrorText(Handle *storage,
	RgnHandle blankRgn,
	short message,
	GMParamBlockPtr params,
	OSErr theOSErr);


	/*
	 * The following function(s) are defined in JADG.c, and are
	 * for convenience's sake.
	 */
	
extern void adErrPStrCpy(GMParamBlockPtr params, unsigned char *source);
extern void adErrPStrCat(GMParamBlockPtr params, unsigned char *source);
