/* include/types */
typedef	unsigned char		Byte;
typedef char				SignedByte;
typedef	char *				Ptr;
typedef	Ptr *				Handle;
typedef	short				(*ProcPtr)();
typedef	char				Boolean;

#define	TRUE	(-1)
#define	FALSE	0

#define	String(x)		struct {						\
								unsigned char length;	\
								unsigned char text[x];	\
							}
typedef	String(255)			Str255;
typedef Str255 *			StringPtr;
typedef Str255 **			StringHandle;

typedef short				OSErr;
typedef long				OSType;


/* include/quickdraw */
#define	srcCopy			0
#define	srcOr			1
#define	srcXor			2
#define	srcBic			3
#define	notSrcCopy		4
#define	notSrcOr		5
#define	notSrcXor		6
#define	notSrcBic		7
#define	patCopy			8
#define	patOr			9
#define	patXor			10
#define	patBic			11
#define	notPatCopy		12
#define	notPatOr		13
#define	notPatXor		14
#define	notPatBic		15

#define	normalBit		0
#define	inverseBit		1
#define	redBit			4
#define	greenBit		3
#define	blueBit			2
#define	cyanBit			8
#define	magentaBit		7
#define	yellowBit		6
#define	blackBit		5

#define	blackColor		33
#define	whiteColor		30
#define	redColor		205
#define	greenColor		341
#define	blueColor		409
#define	cyanColor		273
#define	magentaColor	137
#define	yellowColor		69

#define	picLParen		0
#define	picRParen		1

typedef	char				QDByte;
typedef	QDByte *			QDPtr;
typedef	QDPtr *				QDHandle;
typedef unsigned char		Pattern[8];
typedef int 				Bits16[16];

#define	frameMode	0
#define	paintMode	1
#define	eraseMode	2
#define	invertMode	3
#define	fillMode	4

typedef	unsigned short		Style;
#define	boldStyle		0x01
#define	italicStyle		0x02
#define	underlineStyle	0x04
#define	outlineStyle	0x08
#define	shadowStyle		0x10
#define	condenseStyle	0x20
#define	extendStyle		0x40

struct FontInfo {
	short	ascent;
	short	descent;
	short	widMax;
	short	leading;
};
typedef struct FontInfo 	FontInfo;

struct Point {
	short	v;
	short	h;
};
typedef	struct Point		Point;

#define	vh(x)	((int *)(&(x).v))

struct Rect {
	short	top;
	short	left;
	short	bottom;
	short	right;
};
typedef struct Rect			Rect;

#define	topLeft(x)	(*(struct Point *)(&(x).top))
#define	botRight(x)	(*(struct Point *)(&(x).bottom))

struct BitMap {
	QDPtr		baseAddr;
	short		rowBytes;
	Rect		bounds;
};
typedef struct BitMap		BitMap;

struct Cursor {
	Bits16			data;
	Bits16			mask;
	Point			hotSpot;
};
typedef struct Cursor		Cursor;

struct PenState {
	Point			pnLoc;
	Point			pnSize;
	short			pnMode;
	Pattern			pnPat;
};
typedef struct PenState		PenState;

struct Region {
	short		rgnSize;
	Rect		rgnBBox;
};
typedef struct Region		Region;
typedef	struct Region *		RgnPtr;
typedef	struct Region **	RgnHandle;

struct Picture {
	short		picSize;
	Rect		picFrame;
};
typedef struct Picture		Picture;
typedef	struct Picture *	PicPtr;
typedef	struct Picture **	PicHandle;

struct Polygon {
	short			polySize;
	Rect			polyBBox;
	Point			polyPoints[1];
};
typedef struct Polygon		Polygon;
typedef	struct Polygon *	PolyPtr;
typedef	struct Polygon **	PolyHandle;

struct QDProcs {
	QDPtr	textProc;
	QDPtr	lineProc;
	QDPtr	rectProc;
	QDPtr	rRectProc;
	QDPtr	ovalProc;
	QDPtr	arcProc;
	QDPtr	polyProc;
	QDPtr	rgnProc;
	QDPtr	bitsProc;
	QDPtr	commentProc;
	QDPtr	txMeasProc;
	QDPtr	getPicProc;
	QDPtr	putPicProc;
};
typedef struct QDProcs		QDProcs;
typedef	struct QDProcs *	QDProcsPtr;

struct GrafPort {
	short				device;
	BitMap				portBits;
	Rect				portRect;
	RgnHandle			visRgn;
	RgnHandle			clipRgn;
	Pattern				bkPat;
	Pattern				fillPat;
	Point				pnLoc;
	Point				pnSize;
	short				pnMode;
	Pattern				pnPat;
	short				pnVis;
	short				txFont;
	Style				txFace;
	short				txMode;
	short				txSize;
	long				spExtra;
	long				fgColor;
	long				bkColor;
	short				colorBit;
	short				patStretch;
	QDHandle			picSave;
	QDHandle			rgnSave;
	QDHandle			polySave;
	QDProcsPtr			grafProcs;
};
typedef struct GrafPort		GrafPort;
typedef	struct GrafPort *	GrafPtr;

GrafPtr				thePort;
Pattern				white;
Pattern				black;
Pattern				gray;
Pattern				ltGray;
Pattern				dkGray;
Cursor				arrow;
BitMap				screenBits;
long				randSeed;

pascal void					InitGraf()			=	0xa86e;
pascal void					OpenPort()			=	0xa86f;
pascal void					InitPort()			=	0xa86d;
pascal void					ClosePort()			=	0xa87d;
pascal void					SetPort()			=	0xa873;
pascal void					GetPort()			=	0xa874;
pascal void					GrafDevice()		=	0xa872;
pascal void					SetPortBits()		=	0xa875;
pascal void					PortSize()			=	0xa876;
pascal void					MovePortTo()		=	0xa877;
pascal void					SetOrigin()			=	0xa878;
pascal void					SetClip()			=	0xa879;
pascal void					GetClip()			=	0xa87a;
pascal void					ClipRect()			=	0xa87b;
pascal void					BackPat()			=	0xa87c;
pascal void					InitCursor()		=	0xa850;
pascal void					SetCursor()			=	0xa851;
pascal void					HideCursor()		=	0xa852;
pascal void					ShowCursor()		=	0xa853;
pascal void					ObscureCursor()		=	0xa856;
pascal void					HidePen()			=	0xa896;
pascal void					ShowPen()			=	0xa897;
pascal void					GetPen()			=	0xa89a;
pascal void					GetPenState()		=	0xa898;
pascal void					SetPenState()		=	0xa899;
pascal void					PenSize()			=	0xa89b;
pascal void					PenMode()			=	0xa89c;
pascal void					PenPat()			=	0xa89d;
pascal void					PenNormal()			=	0xa89e;
pascal void					MoveTo()			=	0xa893;
pascal void					Move()				=	0xa894;
pascal void					LineTo()			=	0xa891;
pascal void					Line()				=	0xa892;
pascal void					TextFont()			=	0xa887;
pascal void					TextFace()			=	0xa888;
pascal void					TextMode()			=	0xa889;
pascal void					TextSize()			=	0xa88a;
pascal void					SpaceExtra()		=	0xa88e;
pascal void					DrawChar()			=	0xa883;
pascal void					DrawString()		=	0xa884;
pascal void					DrawText()			=	0xa885;
pascal short				CharWidth()			=	0xa88d;
pascal short				StringWidth()		=	0xa88c;
pascal short				TextWidth()			=	0xa886;
pascal void					GetFontInfo()		=	0xa88b;
pascal void					SetRect()			=	0xa8a7;
pascal void					OffsetRect()		=	0xa8a8;
pascal void					InsetRect()			=	0xa8a9;
pascal Boolean				SectRect()			=	0xa8aa;
pascal void					UnionRect()			=	0xa8ab;
pascal Boolean				PtInRect()			=	0xa8ad;
pascal void					Pt2Rect()			=	0xa8ac;
pascal void					PtToAngle()			=	0xa8c3;
pascal Boolean				EqualRect()			=	0xa8a6;
pascal Boolean				EmptyRect()			=	0xa8ae;
pascal void					FrameRect()			=	0xa8a1;
pascal void					PaintRect()			=	0xa8a2;
pascal void					EraseRect()			=	0xa8a3;
pascal void					InvertRect()		=	0xa8a4;
pascal void					FillRect()			=	0xa8a5;
pascal void					FrameRoundRect()	=	0xa8b0;
pascal void					PaintRoundRect()	=	0xa8b1;
pascal void					EraseRoundRect()	=	0xa8b2;
pascal void					InvertRoundRect()	=	0xa8b3;
pascal void					FillRoundRect()		=	0xa8b4;
pascal RgnHandle			NewRgn()			=	0xa8d8;
pascal void					DisposeRgn()		=	0xa8d9;
pascal void					CopyRgn()			=	0xa8dc;
pascal void					SetEmptyRgn()		=	0xa8dd;
pascal void					SetRectRgn()		=	0xa8de;
pascal void					RectRgn()			=	0xa8df;
pascal void					OpenRgn()			=	0xa8da;
pascal void					CloseRgn()			=	0xa8db;
pascal void					OffsetRgn()			=	0xa8e0;
pascal void					InsetRgn()			=	0xa8e1;
pascal void					SectRgn()			=	0xa8e4;
pascal void					UnionRgn()			=	0xa8e5;
pascal void					DiffRgn()			=	0xa8e6;
pascal void					XorRgn()			=	0xa8e7;
pascal Boolean				PtInRgn()			=	0xa8e8;
pascal Boolean				RectInRgn()			=	0xa8e9;
pascal Boolean				EqualRgn()			=	0xa8e3;
pascal Boolean				EmptyRgn()			=	0xa8e2;
pascal void					FrameRgn()			=	0xa8d2;
pascal void					PaintRgn()			=	0xa8d3;
pascal void					EraseRgn()			=	0xa8d4;
pascal void					InvertRgn()			=	0xa8d5;
pascal void					FillRgn()			=	0xa8d6;
pascal void					ScrollRect()		=	0xa8ef;
pascal void					CopyBits()			=	0xa8ec;
pascal void					AddPt()				=	0xa87e;
pascal void					SubPt()				=	0xa87f;
pascal void					SetPt()				=	0xa880;
pascal Boolean				EqualPt()			=	0xa881;
pascal void					LocalToGlobal()		=	0xa870;
pascal void					GlobalToLocal()		=	0xa871;
pascal short				Random()			=	0xa861;
pascal Boolean				GetPixel()			=	0xa865;
pascal void					StuffHex()			=	0xa866;
pascal void					ScalePt()			=	0xa8f8;
pascal void					MapPt()				=	0xa8f9;
pascal void					MapRect()			=	0xa8fa;
pascal void					MapRgn()			=	0xa8fb;
pascal PicHandle			OpenPicture()		=	0xa8f3;
pascal void					PicComment()		=	0xa8f2;
pascal void					ClosePicture()		=	0xa8f4;
pascal void					DrawPicture()		=	0xa8f6;
pascal void					KillPicture()		=	0xa8f5;
pascal PolyHandle			OpenPoly()			=	0xa8cb;
pascal void					ClosePoly()			=	0xa8cc;
pascal void					KillPoly()			=	0xa8cd;
pascal void					OffsetPoly()		=	0xa8ce;
pascal void					FramePoly()			=	0xa8c6;
pascal void					PaintPoly()			=	0xa8c7;
pascal void					ErasePoly()			=	0xa8c8;
pascal void					InvertPoly()		=	0xa8c9;
pascal void					FillPoly()			=	0xa8ca;
pascal void					MapPoly()			=	0xa8fc;
pascal void					SetStdProcs()		=	0xa8ea;
pascal void					StdText()			=	0xa882;
pascal void					StdLine()			=	0xa890;
pascal void					StdRect()			=	0xa8a0;
pascal void					StdRRect()			=	0xa8af;
pascal void					StdOval()			=	0xa8b6;
pascal void					StdArc()			=	0xa8bd;
pascal void					StdPoly()			=	0xa8c5;
pascal void					StdRgn()			=	0xa8d1;
pascal void					StdBits()			=	0xa8eb;
pascal void					StdComment()		=	0xa8f1;
pascal short				StdTxMeasure()		=	0xa8ed;
pascal void					StdGetPic()			=	0xa8ee;
pascal void					StdPutPic()			=	0xa8f0;
pascal void					ForeColor()			=	0xa862;
pascal void					BackColor()			=	0xa863;
pascal void					ColorBit()			=	0xa864;
pascal void					FrameOval()			=	0xa8b7;
pascal void					PaintOval()			=	0xa8b8;
pascal void					EraseOval()			=	0xa8b9;
pascal void					InvertOval()		=	0xa8ba;
pascal void					FillOval()			=	0xa8bb;
pascal void					FrameArc()			=	0xa8be;
pascal void					PaintArc()			=	0xa8bf;
pascal void					EraseArc()			=	0xa8c0;
pascal void					InvertArc()			=	0xa8c1;
pascal void					FillArc()			=	0xa8c2;

char *ctop();
char *ptoc();
#define	pass(x)	(*((long *)&(x)))

/* include/apple */
#define	lapSize	20
#define	ddpSize	26
#define	nbpSize	26
#define	atpSize	56

typedef short			ABCallType;

#define	tLAPRead		0
#define	tLAPWrite		1
#define	tDDPRead		2
#define	tDDPWrite		3
#define	tNBPLookup		4
#define	tNBPConfirm		5
#define	tNBPRegister	6
#define	tATPSndRequest	7
#define	tATPGetRequest	8
#define	tATPSdRsp		9
#define	tATPAddRsp		10

typedef short			ABProtoType;

#define	lapProto		0
#define	ddpProto		1
#define	nbpProto		2
#define	atpProto		3

typedef unsigned char	ABByte;
typedef String(32)		Str32;

typedef struct {
	Byte			dstNodeId;
	Byte			srcNodeId;
	Byte			LAPProtType;
} LAPAdrBlock;

typedef struct {
	short			aNet;
	Byte			aNode;
	Byte			aSocket;
} AddrBlock;

typedef struct {
	Str32			objStr;
	Str32			typeStr;
	Str32			zoneStr;
} EntityName, *EntityPtr;

typedef struct {
	Byte			retransInterval;
	Byte			retransCount;
} RetransType;

typedef struct {
	short			buffSize;
	Ptr				buffPtr;
	short			dataSize;
	long			userBytes;
} BDSElement;
typedef BDSElement	BDSType[8];
typedef BDSType *	BDSPtr;

typedef struct {
	ABCallType		abOpcode;
	short			abResult;
	long			abUserReference;
	LAPAdrBlock		lapAddress;
	short			lapReqCount;
	short			lapActCount;
	Ptr				lapDataPtr;
} LAPRecord, *LAPRecPtr, **LAPRecHdl;

typedef struct {
	ABCallType		abOpcode;
	short			abResult;
	long			abUserReference;
	Byte			ddpType;
	Byte			ddpSocket;
	AddrBlock		ddpAddress;
	short			ddpReqCount;
	short			ddpActCount;
	Ptr				ddpDataPtr;
	Byte			ddpNodeID;
} DDPRecord, *DDPRecPtr, **DDPRecHdl;

typedef struct {
	ABCallType		abOpcode;
	short			abResult;
	long			abUserReference;
	EntityPtr		nbpEntityPtr;
	Ptr				nbpBufPtr;
	short			nbpBufSize;
	short			nbpDataField;
	AddrBlock		nbpAddress;
	RetransType		nbpRetransmitInfo;
} NBPRecord, *NBPRecPtr, **NBPRecHdl;

typedef struct {
	ABCallType		abOpcode;
	short			abResult;
	long			abUserReference;
	Byte			atpSocket;
	AddrBlock		atpAddress;
	short			atpReqCount;
	Ptr				atpDataPtr;
	BDSPtr			atpRspBDSPtr;
	unsigned char	atpBitMap;
	short			atpTransId;
	short			atpActCount;
	long			atpUserData;
	Boolean			atpXO;
	Boolean			atpEOM;
	Byte			atpTimeOut;
	Byte			atpRetries;
	Byte			atpNumBufs;
	Byte			atpNumRsp;
	Byte			atpBDSSize;
} ATPRecord, *ATPRecPtr, **ATPRecHdl;

pascal OSErr			MPPOpen();
pascal OSErr			LAPOpenProtocol();
pascal OSErr			LAPCloseProtocol();
pascal OSErr			LAPRead();
pascal OSErr			LAPWrite();
pascal OSErr			DDPOpenSocket();
pascal OSErr			DDPCloseSocket();
pascal OSErr			DDPRead();
pascal OSErr			DDPWrite();
pascal OSErr			NBPLoad();
pascal OSErr			NBPUnload();
pascal OSErr			NBPLookup();
pascal OSErr			NBPConfirm();
pascal OSErr			NBPRegister();
pascal OSErr			NBPRemove();
pascal OSErr			NBPExtract();
pascal OSErr			ATPLoad();
pascal OSErr			ATPUnload();
pascal OSErr			ATPOpenSocket();
pascal OSErr			ATPCloseSocket();
pascal OSErr			ATPSndRequest();
pascal OSErr			ATPGetRequest();
pascal OSErr			ATPSndRsp();
pascal OSErr			ATPAddRsp();
pascal void				RemoveHdlBlks();
pascal Byte				GetNodeNumber();

/* include/toolutility */

#define sysPatListID	0

#define	iBeamCursor	1 
#define	crossCursor	2 
#define	plusCursor	3 
#define	watchCursor	4 

typedef long				Fixed;

struct Int64Bit {
	long	hiLong;
	long	loLong;
};
typedef struct Int64Bit		Int64Bit;

typedef struct Cursor *		CursPtr;
typedef struct Cursor **	CursHandle;

typedef struct Pattern *	PatPtr;
typedef struct Pattern **	PatHandle;

pascal StringHandle			NewString()			=	0xa906;
pascal void					SetString()			=	0xa907;
pascal StringHandle			GetString()			=	0xa9ba;
pascal long					Munger()			=	0xa9e0;
pascal Fixed				FixRatio()			=	0xa869;
pascal Fixed				FixMul()			=	0xa868;
pascal short				FixRound()			=	0xa86c;
pascal Boolean				BitTst()			=	0xa85d;
pascal void					BitSet()			=	0xa85e;
pascal void					BitClr()			=	0xa85f;
pascal long					BitAnd()			=	0xa858;
pascal long					BitOr()				=	0xa85b;
pascal long					BitXor()			=	0xa859;
pascal long					BitNot()			=	0xa85a;
pascal long					BitShift()			=	0xa85c;
pascal short				HiWord()			=	0xa86a;
pascal short				LoWord()			=	0xa86b;
pascal void					LongMul()			=	0xa867;
pascal PicHandle			GetPicture()		=	0xa9bc;
pascal void					GetIndString();
pascal void					GetIndPattern();
pascal long					DeltaPoint()		=	0xa94f;
pascal Fixed				SlopeFromAngle()	=	0xa8bc;
pascal short				AngleFromSlope()	=	0xa8c4;
pascal Handle				GetIcon()			=	0xa9bb;
pascal void					PlotIcon()			=	0xa94b;
pascal PatHandle			GetPattern()		=	0xa9b8;
pascal CursHandle			GetCursor()			=	0xa9b9;
pascal void					ShieldCursor()		=	0xa855;
pascal void					PackBits()			=	0xa8cf;
pascal void					UnpackBits()		=	0xa8d0;

/* include/window */


#define	documentProc	0
#define	dBoxProc		1
#define	plainDBox		2
#define	altDBoxProc		3
#define	noGrowDocProc	4
#define	rDocProc		16

#define	dialogKind		2
#define	userKind		8

#define	inDesk			0
#define	inMenuBar		1
#define	inSysWindow		2
#define	inContent		3
#define	inDrag			4
#define	inGrow			5
#define	inGoAway		6

#define	noConstraint	0
#define	hAxisOnly		1
#define	vAxisOnly		2

#define	wDraw			0
#define	wHit			1
#define	wCalcRgns		2
#define	wNew			3
#define	wDispose		4
#define	wGrow			5
#define	wDrawGIcon		6

#define	wNoHit			0
#define	wInContent		1
#define	wInDrag			2
#define	wInGrow			3
#define	wInGoAway		4

typedef	struct WindowRecord *	WindowPeek;

struct WindowRecord {
	GrafPort				port;
	short					windowKind;
	char					visible;
	char					hilited;
	char					goAwayFlag;
	char					spareFlag;
	RgnHandle				strucRgn;
	RgnHandle				contRgn;
	RgnHandle				updateRgn;
	Handle					windowDefProc;
	Handle					dataHandle;
	StringHandle			titleHandle;
	short					titleWidth;
	Handle					controlList;
	WindowPeek				nextWindow;
	PicHandle				windowPic;
	long					refCon;
};
typedef	struct WindowRecord	WindowRecord;
typedef	GrafPtr				WindowPtr;

pascal void						InitWindows()		=	0xa912;
pascal void						GetWMgrPort()		=	0xa910;
pascal WindowPtr				NewWindow()			=	0xa913;
pascal WindowPtr				GetNewWindow()		=	0xa9bd;
pascal void						CloseWindow()		=	0xa92d;
pascal void						DisposeWindow()		=	0xa914;
pascal void						SetWTitle()			=	0xa91a;
pascal void						GetWTitle()			=	0xa919;
pascal void						SelectWindow()		=	0xa91f;
pascal void						HideWindow()		=	0xa916;
pascal void						ShowWindow()		=	0xa915;
pascal void						ShowHide()			=	0xa908;
pascal void						HiliteWindow()		=	0xa91c;
pascal void						BringToFront()		=	0xa920;
pascal void						SendBehind()		=	0xa921;
pascal WindowPtr				FrontWindow()		=	0xa924;
pascal void						DrawGrowIcon()		=	0xa904;
pascal short					FindWindow()		=	0xa92c;
pascal Boolean					TrackGoAway()		=	0xa91e;
pascal void						MoveWindow()		=	0xa91b;
pascal void						DragWindow()		=	0xa925;
pascal long						GrowWindow()		=	0xa92b;
pascal void						SizeWindow()		=	0xa91d;
pascal void						InvalRect()			=	0xa928;
pascal void						InvalRgn()			=	0xa927;
pascal void						ValidRect()			=	0xa92a;
pascal void						ValidRgn()			=	0xa929;
pascal void						BeginUpdate()		=	0xa922;
pascal void						EndUpdate()			=	0xa923;
pascal void						SetWRefCon()		=	0xa918;
pascal long						GetWRefCon()		=	0xa917;
pascal void						SetWindowPic()		=	0xa92e;
pascal PicHandle				GetWindowPic()		=	0xa92f;
pascal long						PinRect()			=	0xa94e;
pascal long						DragGrayRgn()		=	0xa905;
pascal Boolean					CheckUpdate()		=	0xa911;
pascal void						ClipAbove()			=	0xa90b;
pascal void						SaveOld()			=	0xa90e;
pascal void						DrawNew()			=	0xa90f;
pascal void						PaintOne()			=	0xa90c;
pascal void						PaintBehind()		=	0xa90d;
pascal void						CalcVis()			=	0xa909;
pascal void						CalcVisBehind()		=	0xa90a;

/* include/control */
#define	pushButProc		0
#define	checkBoxProc	1
#define	radioButProc	2
#define	useWFont		8
#define	scrollBarProc	16

#define	inButton		10
#define	inCheckBox		11
#define	inUpButton		20
#define	inDownButton	21
#define	inPageUp		22
#define	inPageDown		23
#define	inThumb			129

#define	drawCntl		0
#define	testCntl		1
#define	calcCRgns		2
#define	initCntl		3
#define	dispCntl		4
#define	posCntl			5
#define	thumbCntl		6
#define	dragCntl		7
#define	autoTrack		8

typedef	struct ControlRecord **		ControlHandle;

struct ControlRecord {
	ControlHandle			nextControl;
	WindowPtr				contrlOwner;
	Rect					contrlRect;
	char					contrlVis;
	char					contrlHilite;
	short					contrlValue;
	short					contrlMin;
	short					contrlMax;
	Handle					contrlProc;
	Handle					contrlData;
	ProcPtr					contrlAction;
	long					contrlRfCon;
	Str255					contrlTitle;
};
typedef struct ControlRecord		ControlRecord;
typedef	struct ControlRecord *		ControlPtr;


pascal ControlHandle			NewControl()		=	0xa954;
pascal ControlHandle			GetNewControl()		=	0xa9be;
pascal void						DisposeControl()	=	0xa955;
pascal void						KillControls()		=	0xa956;
pascal void						SetCTitle()			=	0xa95f;
pascal void						GetCTitle()			=	0xa95e;
pascal void						HideControl()		=	0xa958;
pascal void						ShowControl()		=	0xa957;
pascal void						DrawControls()		=	0xa969;
pascal void						HiliteControl()		=	0xa95d;
pascal short					TestControl()		=	0xa966;
pascal short					FindControl()		=	0xa96c;
pascal short					TrackControl()		=	0xa968;
pascal void						MoveControl()		=	0xa959;
pascal void						DragControl()		=	0xa967;
pascal void						SizeControl()		=	0xa95c;
pascal void						SetCtlValue()		=	0xa963;
pascal short					GetCtlValue()		=	0xa960;
pascal void						SetCtlMin()			=	0xa964;
pascal short					GetCtlMin()			=	0xa961;
pascal void						SetCtlMax()			=	0xa965;
pascal short					GetCtlMax()			=	0xa962;
pascal void						SetCRefCon()		=	0xa95b;
pascal long						GetCRefCon()		=	0xa95a;
pascal void						SetCtlAction()		=	0xa96b;
pascal ProcPtr					GetCtlAction()		=	0xa96a;

/* include/ctypes */
extern char ctp_[];

#define isalpha(x) (ctp_[(x)+1]&0x03)
#define isupper(x) (ctp_[(x)+1]&0x01)
#define islower(x) (ctp_[(x)+1]&0x02)
#define isdigit(x) (ctp_[(x)+1]&0x04)
#define isxdigit(x) (ctp_[(x)+1]&0x08)
#define isalnum(x) (ctp_[(x)+1]&0x07)
#define isspace(x) (ctp_[(x)+1]&0x10)
#define ispunct(x) (ctp_[(x)+1]&0x40)
#define iscntrl(x) (ctp_[(x)+1]&0x20)
#define isprint(x) (ctp_[(x)+1]&0xc7)
#define isgraph(x) (ctp_[(x)+1]&0x47)
#define isascii(x) (((x)&0x80)==0)

#define toascii(x) ((x)&127)
#define _tolower(x) ((x)|0x20)
#define _toupper(x) ((x)&0x5f)

/* include/deskutility */

#define	undoCmd		0
#define	cutCmd		2
#define	copyCmd		3
#define	pasteCmd	4
#define	clearCmd	5

#define	accEvent	64
#define	accRun		65
#define	accCursor	66
#define	accMenu		67
#define	accUndo		68
#define	accCut		70
#define	accCopy		71
#define	accPaste	72
#define	accClear	73

struct DCE {
	char **					dCtlDriver;
	unsigned short			dCtlFlags;
	short					dCtlQueue;
	struct ParamBlkRec *	dCtlQHead;
	struct ParamBlkRec *	dCtlQTail;
	long					dCtlPosition;
	char **					dCtlStorage;
	short					dCtlRefNum;
	long					dCtlCurTicks;
	WindowPtr				dCtlWindow;
	short					dCtlDelay;
	unsigned short			dCtlEMask;
	short					dCtlMenu;
};
typedef struct DCE		DCE;
typedef struct DCE *	DCEPtr;

pascal short	OpenDeskAcc()			=	0xa9b6;
pascal void		CloseDeskAcc()			=	0xa9b7;
pascal void		SystemClick()			=	0xa9b3;
pascal Boolean	SystemEdit()			=	0xa9c2;
pascal void		SystemTask()			=	0xa9b4;
pascal Boolean	SystemEvent()			=	0xa9b2;
pascal void		SystemMenu()			=	0xa9b5;

/* include/textedit */
#define	teJustLeft		0
#define	teJustCenter	1
#define	teJustRight		-1

typedef	char		Chars[32001];
typedef char *		CharsPtr;
typedef char **		CharsHandle;

struct TERec {
	Rect				destRect;
	Rect				viewRect;
	Rect				selRect;
	short				lineHeight;
	short				fontAscent;
	Point				selPoint;
	short				selStart;
	short				selEnd;
	short				active;
	long				wordBreak;
	long				clikLoop;
	long				clickTime;
	short				clickLoc;
	long				caretTime;
	short				caretState;
	short				just;
	short				teLength;
	Handle				hText;
	short				recalBack;
	short				recalLines;
	short				clikStuff;
	short				crOnly;
	short				txFont;
	short				txFace;
	short				txMode;
	short				txSize;
	GrafPtr				inPort;
	Ptr					highHook;
	Ptr					caretHook;
	short				nLines;
	short				lineStarts[32001];
};
typedef struct TERec		TERec;
typedef struct TERec *		TEPtr;
typedef struct TERec **		TEHandle;

pascal void					TEInit()			=	0xa9cc;
pascal TEHandle				TENew()				=	0xa9d2;
pascal void					TESetText()			=	0xa9cf;
pascal CharsHandle			TEGetText()			=	0xa9cb;
pascal void					TEDispose()			=	0xa9cd;
pascal void					TEKey()				=	0xa9dc;
pascal void					TECut()				=	0xa9d6;
pascal void					TECopy()			=	0xa9d5;
pascal void					TEPaste()			=	0xa9db;
pascal void					TEDelete()			=	0xa9d7;
pascal void					TEInsert()			=	0xa9de;
pascal void					TESetSelect()		=	0xa9d1;
pascal void					TESetJust()			=	0xa9df;
pascal void					TEClick()			=	0xa9d4;
pascal void					TEIdle()			=	0xa9da;
pascal void					TEActivate()		=	0xa9d8;
pascal void					TEDeactivate()		=	0xa9d9;
pascal void					TEUpdate()			=	0xa9d3;
pascal void					TextBox()			=	0xa9ce;
pascal void					TEScroll()			=	0xa9dd;
pascal void					TECalText()			=	0xa9d0;
pascal OSErr				TEFromScrap();
pascal OSErr				TEToScrap();
	   Handle				TEScrapHndl();
	   long					TEGetScrpLen();
pascal void					TESetScrpLen();

/* include/dialog */
#define	ctrlItem	0x04
#define	btnCtrl		0x00
#define	chkCtrl		0x01
#define	radCtrl		0x02
#define	resCtrl		0x03
#define	statText	0x08
#define	editText	0x10
#define	iconItem	0x20
#define	picItem		0x40
#define	userItem	0x00
#define	itemDisable	0x80

#define	OK			1
#define	Cancel		2

#define	stopIcon	0
#define	noteIcon	1
#define	ctnIcon		2

struct DialogRecord {
	WindowRecord		window;
	Handle				items;
	TEHandle			textH;
	short				editField;
	short				editOpen;
	short				aDefItem;
};
typedef struct DialogRecord		DialogRecord;
typedef struct DialogRecord *	DialogPeek;
typedef WindowPtr				DialogPtr;

struct DialogTemplate {
	Rect		boundsRect;
	short		procID;
	char		visible;
	char		filler1;
	char		goAwayFlag;
	char		filler2;
	long		refCon;
	short		itemsID;
	Str255		title;
};
typedef struct DialogTemplate		DialogTemplate;
typedef struct DialogTemplate *		DialogTPtr;
typedef struct DialogTemplate **	DialogTHandle;

struct StageList {
	char		boldItem;
	char		boxDrawn;
	char		sound;
};
typedef struct StageList	StageList[4];

struct AlertTemplate {
	Rect 			boundsRect;
	short			itemsID;
	StageList		stages;
};

#define	volBits		0x3
#define	alBit		0x4
#define	OKDismissal	0x8

pascal void						InitDialogs()		=	0xa97b;
pascal void						ErrorSound()		=	0xa98c;
pascal DialogPtr				NewDialog()			=	0xa97d;
pascal DialogPtr				GetNewDialog()		=	0xa97c;
pascal void						CloseDialog()		=	0xa982;
pascal void						DisposDialog()		=	0xa983;
pascal void						CouldDialog()		=	0xa979;
pascal void						FreeDialog()		=	0xa97a;
pascal void						ModalDialog()		=	0xa991;
pascal Boolean					IsDialogEvent()		=	0xa97f;
pascal Boolean					DialogSelect()		=	0xa980;
pascal void						DrawDialog()		=	0xa981;
pascal short					Alert()				=	0xa985;
pascal short					StopAlert()			=	0xa986;
pascal short					NoteAlert()			=	0xa987;
pascal short					CautionAlert()		=	0xa988;
pascal void						CouldAlert()		=	0xa989;
pascal void						FreeAlert()			=	0xa98a;
pascal void						ParamText()			=	0xa98b;
pascal void						GetDItem()			=	0xa98d;
pascal void						SetDItem()			=	0xa98e;
pascal void						GetIText()			=	0xa990;
pascal void						SetIText()			=	0xa98f;
pascal void						SelIText()			=	0xa97e;
	   short					GetAlrtStage();
	   void						ResetAlrtStage();
pascal void						DlgCopy();
pascal void						DlgCut();
pascal void						DlgPaste();
pascal void						DlgDelete();
pascal void						SetDAFont();

/* include/osutil */
struct SysParamType {
	long		valid;
	short		portA;
	short		portB;
	long		alarm;
	short		font;
	short		kbdPrint;
	short		volClick;
	short		misc;
};
typedef struct SysParamType		SysParamType;
typedef struct SysParamType *	SysPtr;

#define	vType		1
#define	ioQType		2
#define	drvQType	3
#define	evType		4
#define	fsQType		5

typedef struct QElem {
	struct QElem *	qLink; 
	short			qType; 
	short			qData[1]; 
} QElem, *QElemPtr;

typedef struct {
	short		qFlags; 
	QElemPtr	qHead; 
	QElemPtr	qTail; 
} QHdr, *QHdrPtr;

struct DateTimeRec {
	short	year;
	short	month;
	short	day;
	short	hour;
	short	minute;
	short	second;
	short	dayOfWeek;
};
typedef struct DateTimeRec	DateTimeRec;

	   OSErr	HandToHand();
	   OSErr	PtrToHand();
	   OSErr	PtrToXHand();
	   OSErr	HandAndHand();
	   OSErr	PtrAndHand();
	   Boolean	EqualString();
	   void		UprString();
	   OSErr	ReadDateTime();
	   void		GetDateTime();
	   OSErr	SetDateTime();
	   void		Date2Secs();
	   void		Secs2Date();
	   void		GetTime();
	   void		SetTime();
	   OSErr	InitUtil();
	   SysPtr	GetSysPPtr();
	   OSErr	WriteParam();
	   void		Enqueue();
	   OSErr	Dequeue();
	   void		SysError();
	   void		Delay();
	   void		SetTrapAddress();
	   QHdrPtr	GetEvQHdr();
	   long		GetTrapAddress();
pascal void		SysBeep()					=	0xa9c8;

/* include/disk */

#define	currPos		0x00
#define	absPos		0x01
#define relPos		0x03
#define rdVerify	0x40

struct DrvSts {
	short		track;
	SignedByte	writeProt;
	SignedByte	diskInPlace;
	SignedByte	installed;
	SignedByte	sides;
	QElemPtr	qLink;
	short		qType;
	short		dQDrive;
	short		dQRefNUm;
	short		dQFSID;
	SignedByte	twoSideFmt;
	SignedByte	needsFlush;
	short		diskErrs;
};

	OSErr	DiskEject();
	OSErr	SetTagBuffer();
	OSErr	DriveStatus();

/* include/errno */

extern int errno;
#define ENOENT	-1
#define E2BIG	-2
#define EBADF	-3
#define ENOMEM	-4
#define EEXIST	-5
#define EINVAL	-6
#define ENFILE	-7
#define EMFILE	-8
#define ENOTTY	-9
#define EACCES	-10

#define ERANGE	-20
#define EDOM	-21

/* include/event */

#define	nullEvent	0
#define	mouseDown	1
#define	mouseUp		2
#define	keyDown		3
#define	keyUp		4
#define	autoKey		5
#define	updateEvt	6
#define	diskEvt		7
#define	activateEvt	8
#define	abortEvt	9
#define	networkEvt	10
#define	driverEvt	11
#define	app1Evt		12
#define	app2Evt		13
#define	app3Evt		14
#define	app4Evt		15

#define	everyEvent	0xffff

#define	nullMask	0x0001
#define	mDownMask	0x0002
#define	mUpMask		0x0004
#define	keyDownMask	0x0008
#define	keyUpMask	0x0010
#define	autoKeyMask	0x0020
#define	updateMask	0x0040
#define	diskMask	0x0080
#define	activMask	0x0100
#define	abortMask	0x0200
#define	networkMask	0x0400
#define	driverMask	0x0800
#define	app1Mask	0x1000
#define	app2Mask	0x2000
#define	app3Mask	0x4000
#define	app4Mask	0x8000

#define	charCodeMask	0x000000ff
#define	keyCodeMask		0x0000ff00

#define	activeFlag		0x0001

#define	optionKey		0x0800
#define	alphaLock		0x0400
#define	shiftKey		0x0200
#define	cmdKey			0x0100
#define	btnState		0x0080

#define evtNotEnb	1

struct EventRecord {
	short			what;
	long			message;
	long			when;
	Point			where;
	short			modifiers;
};
typedef struct EventRecord	EventRecord;

typedef	long		KeyMap[4];


pascal Boolean		GetNextEvent()		=	0xa970;
pascal Boolean		EventAvail()		=	0xa971;
pascal void			GetMouse()			=	0xa972;
pascal Boolean		Button()			=	0xa974;
pascal Boolean		StillDown()			=	0xa973;
pascal Boolean		WaitMouseUp()		=	0xa977;
pascal void			GetKeys()			=	0xa976;
pascal long			TickCount()			=	0xa975;

	   void			PostEvent();
	   void			FlushEvents();
	   void			SetEventMask();
	   Boolean		OSEventAvail();
	   Boolean		GetOSEvent();
	   long			GetDbleTime();
	   long			GetCaretTime();
	   
/* include/fcntl */
#define O_RDONLY	0
#define O_WRONLY	1
#define O_RDWR		2
#define O_CREAT		0x0100
#define O_TRUNC		0x0200
#define O_EXCL		0x0400
#define O_APPEND	0x0800

/* include/fonts */
/*	Font Numbers	*/

#define	systemFont	0
#define	applFont	1
#define	newYork		2
#define	geneva		3
#define	monaco		4
#define	venice		5
#define	london		6
#define	athens		7
#define	sanFran		8
#define	toronto		9

/* Font Types		*/

#define	propFont	0x9000
#define	fixedFont	0xB000
#define	fontWid		0xACB0

/* Data Types		*/

struct FMInput {
	short			family;
	short			size;
	char			face;
	char			needBits;
	short			device;
	Point			numer;
	Point			denom;
};
typedef struct FMInput		FMInput;

struct FMOutput {
	short			errNum;
	Handle			fontHandle;
	Byte			bold;
	Byte			italic;
	Byte			ulOffset;
	Byte			ulShadow;
	Byte			ulThick;
	Byte			shadow;
	SignedByte		extra;
	Byte			ascent;
	Byte			descent;
	Byte			widMax;
	SignedByte		leading;
	Byte			unused;
	Point			numer;
	Point			denom;
};
typedef struct FMOutput		FMOutput;
typedef	struct FMOutput *	FMOutPtr;

struct FontRec {
	short	fontType;
	short	firstChar;
	short	lastChar;
	short	widMax;
	short	kernMax;
	short	nDescent;
	short	fRectMax;
	short	chHeight;
	short	owTLoc;
	short	ascent;
	short	descent;
	short	leading;
	short	rowWords;
};
typedef struct FontRec		FontRec;
pascal void					InitFonts()			=	0xa8fe;
pascal void					GetFontName()		=	0xa8ff;
pascal void					GetFNum()			=	0xa900;
pascal Boolean				RealFont()			=	0xa902;
pascal void					SetFontLock()		=	0xa903;
pascal FMOutPtr				SwapFont()			=	0xa901;

/* include/inits */
pascal void					InitGraf()			=	0xa86e;
pascal void					InitDialogs()		=	0xa97b;
pascal void					InitFonts()			=	0xa8fe;
pascal void 				InitMenus()			=	0xa930;
pascal void					InitPack()			=	0xa9e5;
pascal void					InitAllPacks()		=	0xa9e6;
pascal void					InitQueue();
pascal short				InitResources()		=	0xa995;
pascal void					TEInit()			=	0xa9cc;
pascal void					InitWindows()		=	0xa912;
pascal void					InitPort()			=	0xa86d;
pascal void					InitCursor()		=	0xa850;

/* include/math */
double sin(), cos(), tan(), cotan();
double asin(), acos(), atan(), atan2();
double ldexp(), frexp(), modf();
double floor(), ceil(), fabs();
double log(), log10(), exp(), sqrt(), pow();
double sinh(), cosh(), tanh();

#define HUGE	1.79e+308
#define LOGHUGE	709.778
#define TINY	2.2e-308
#define LOGTINY	-708.396

/* include/memory */
/* Copyright (C) 1984 by Manx Software Systems, Inc. */

#define	maxSize			0x800000

typedef	long			Size;
typedef	int				MemErr;
typedef	struct Zone *	THz;

struct Zone {
	Ptr			bkLim;
	Ptr			purgePtr;
	Ptr			hFstFree;
	long		zcbFree;
	ProcPtr		gzProc;
	short		moreMast;
	short		flags;
	short		cntRel;
	short		maxRel;
	short		cntNRel;
	short		maxNRel;
	short		cntEmpty;
	short		cntHandles;
	long		minCBFree;
	ProcPtr		purgeProc;
	Ptr			sparePtr;
	Ptr			allocPtr;
	short		heapData;
};
typedef struct Zone		Zone;

	   void				SetApplBase();
       void				InitApplZone();
	   void				SetApplLimit();
	   void				MaxApplZone();
	   void				SetZone();
	   void				DisposHandle();
	   void				SetHandleSize();
	   void				ReallocHandle();
	   void				DisposPtr();
	   void				SetPtrSize();
	   void				ResrvMem();
	   void				PurgeMem();
	   void				EmptyHandle();
	   void				HLock();
	   void				HUnlock();
	   void				HPurge();
	   void				HNoPurge();
	   void				MoreMasters();
	   void				SetGrowZone();
	   Boolean			GZCritical();
	   void				BlockMove();
	   MemErr			MemError();
pascal void				InitZone();
	   THz				GetZone();
	   THz				SystemZone();
	   THz				ApplicZone();
	   Handle			NewHandle();
	   Size				GetHandleSize();
	   THz				HandleZone();
	   Handle			RecoverHandle();
	   Ptr				NewPtr();
	   Size				GetPtrSize();
	   THz				PtrZone();
	   long				FreeMem();
	   Size				MaxMem();
	   Size				CompactMem();
	   Handle			GZSaveHnd();
	   Ptr				TopMem();

/* include/menu */
#define	noMark			0
#define	commandMark		17
#define	checkMark		18
#define	diamondMark		19
#define	appleMark		20

#define	mDrawMsg		0
#define	mChooseMsg		1
#define	mSizeMsg		2

#define	textMenuProc	0

struct MenuInfo {
	short			menuID;
	short			menuWidth;
	short			menuHeight;
	Handle			menuProc;
	unsigned long	enableFlags;
	Str255			menuData;
};
typedef struct MenuInfo		MenuInfo;
typedef struct MenuInfo *	MenuPtr;
typedef struct MenuInfo **	MenuHandle;

pascal void 				InitMenus()			=	0xa930;
pascal MenuHandle			NewMenu()			=	0xa931;
pascal MenuHandle			GetMenu()			=	0xa9bf;
pascal void 				DisposeMenu()		=	0xa932;
pascal void 				AppendMenu()		=	0xa933;
pascal void 				AddResMenu()		=	0xa94d;
pascal void 				InsertResMenu()		=	0xa951;
pascal void 				InsertMenu()		=	0xa935;
pascal void 				DrawMenuBar()		=	0xa937;
pascal void 				DeleteMenu()		=	0xa936;
pascal void 				ClearMenuBar()		=	0xa934;
pascal Handle				GetNewMBar()		=	0xa9c0;
pascal Handle				GetMenuBar()		=	0xa93b;
pascal void 				SetMenuBar()		=	0xa93c;
pascal long 				MenuSelect()		=	0xa93d;
pascal long 				MenuKey()			=	0xa93e;
pascal void 				HiliteMenu()		=	0xa938;
pascal void 				SetItem()			=	0xa947;
pascal void 				GetItem()			=	0xa946;
pascal void 				DisableItem()		=	0xa93a;
pascal void 				EnableItem()		=	0xa939;
pascal void 				CheckItem()			=	0xa945;
pascal void 				SetItemIcon()		=	0xa940;
pascal void 				GetItemIcon()		=	0xa93f;
pascal void 				SetItemStyle()		=	0xa942;
pascal void 				GetItemStyle()		=	0xa941;
pascal void 				SetItemMark()		=	0xa944;
pascal void 				GetItemMark()		=	0xa943;
pascal void 				SetMenuFlash()		=	0xa94a;
pascal void 				CalcMenuSize()		=	0xa948;
pascal short 				CountMItems()		=	0xa950;
pascal MenuHandle			GetMHandle()		=	0xa949;
pascal void 				FlashMenuBar()		=	0xa94c;

/* include/packages */
#define	dskInit		2
#define	stdFile		3
#define	flPoint		4
#define	trFunc		5
#define	intUtil		6
#define	bdConv		7

pascal void		InitPack()			=	0xa9e5;
pascal void		InitAllPacks()		=	0xa9e6;
pascal void		Pack0()				=	0xa9e7;
pascal void		Pack1()				=	0xa9e8;
pascal void		Pack2()				=	0xa9e9;
pascal void		Pack3()				=	0xa9ea;
pascal void		Pack4()				=	0xa9eb;
pascal void		FP68K()				=	0xa9eb;
pascal void		Pack5()				=	0xa9ec;
pascal void		Pack6()				=	0xa9ed;
pascal void		Pack7()				=	0xa9ee;

/* Standard File Package */

#define	putDlgID		-3999

#define putSave		1
#define	putCancel	2
#define	putEject	5
#define	putDrive	6
#define	putName		7

#define	getDlgID		-4000

#define	getOpen		1
#define	getCancel	3
#define	getEject	5
#define	getDrive	6
#define	getNmList	7
#define	getScroll	8

struct SFReply {
	char	good;
	char	copy;
	OSType	fType;
	short	vRefNum;
	short	version;
	char	fName[64];
};
typedef struct SFReply	SFReply;

typedef OSType 			SFTypeList[4];
typedef SFTypeList *	SFListPtr;

pascal void		SFPutFile();
pascal void		SFPPutFile();
pascal void		SFGetFile();
pascal void		SFPGetFile();

pascal void		DILoad();
pascal void		DIUnload();
pascal short	DIBadMount();
pascal short	DIFormat();
pascal short	DIVerify();
pascal short	DIZero();

/* International Utilities Package */

#define	shortDate	0x000
#define	longDate	0x100
#define	abbrevDate	0x200

#define currSymLead		0x10
#define currNegSym		0x20
#define currTrailingZ	0x40
#define currLeadingZ	0x80

#define mdy	0
#define dmy	1
#define ymd	2

#define dayLdingZ		0x20
#define mntLdingZ		0x40
#define century			0x80

#define secLeadingZ		0x20
#define minLeadingZ		0x40
#define hrLeadingZ		0x80

#define verUS		0
#define verFrance	1
#define verBritain	2
#define verGermany	3
#define verItaly	4

typedef struct {
	char	decimalPt;
	char 	thousSep;
	char	listSep;
	char	currSym1;
	char 	currSym2;
	char	currSym3;
	Byte	currFmt;
	Byte	dateOrder;
	Byte	shrtDateFmt;
	char	dateSep;
	Byte	timeCycle;
	Byte	timeFmt;
	char	mornStr[4];
	char	eveStr[4];
	char	timeSep;
	char	time1Suff;
	char	time2Suff;
	char	time3Suff;
	char	time4Suff;
	char	time5Suff;
	char	time6Suff;
	char	time7Suff;
	char	time8Suff;
	Byte	metricSys;
	short	intl0Vers;
} Intl0Rec, *Intl0Ptr, **Intl0Hndl;

typedef struct {
	char	days[7][16];
	char	months[12][16];
	Byte	suppressDay;
	Byte	lngDateFmt;
	Byte	dayLeading0;
	Byte	abbrLen;
	char	st0[4];
	char	st1[4];
	char	st2[4];
	char	st3[4];
	char	st4[4];
	short	intl1vers;
	short	localRtn;
} Intl1Rec, *Intl1Ptr, **Intl1Hndl;

pascal Handle	IUGetIntl();
pascal void		IUSetIntl();
pascal void		IUDateString();
pascal void		IUDatePString();
pascal void		IUTimeString();
pascal void		IUTimePString();
pascal Boolean	IUMetric();
pascal short	IUMagString();
pascal short	IUMagIDString();
pascal short	IUCompString();
pascal short	IUEqualString();
pascal void		StringToNum();
pascal void		NumToString();

/* include/pb */

#define	fHasBundle	0x20
#define	fInvisible	0x40

#define	fTrash		-3
#define	fDesktop	-2
#define	fDisk		0

#define fsAtMark	0
#define fsFromStart	1
#define fsFromLEOF	2
#define fsFromMark	3

#define fsCurPerm	0
#define fsRdPerm	1
#define fsWrPerm	2
#define fsRdWrPerm	3

struct Finfo {
	OSType			fdType;
	OSType			fdCreator;
	short			fdFlags;
	Point			fdLocation;
	short			fdFldr;
};
typedef struct Finfo		Finfo;

struct ioParam {
	short			ioRefNum;
	SignedByte		ioVersNum;
	SignedByte 		ioPermssn;
	Ptr				ioMisc;
	Ptr				ioBuffer;
	long			ioReqCount;
	long			ioActCount;
	short			ioPosMode;
	long			ioPosOffset;
};

struct fileParam {
	short			ioFRefNum;
	SignedByte		ioFVersNum;
	SignedByte		filler1;
	short			ioFDirIndex;
	SignedByte		ioFlAttrib;
	SignedByte		ioFlVersNum;
	Finfo			ioFlFndrInfo;
	long			ioFlNum;
	short			ioFlStBlk;
	long			ioFlLgLen;
	long			ioFlPyLen;
	short			ioFlRStBlk;
	long			ioFlRLgLen;
	long			ioFlRPyLen;
	long			ioFlCrDat;
	long			ioFlMdDat;
};

struct volumeParam {
	long	filler2;
	short	ioVolIndex;
	long	ioVCrDate;
	long	ioVLsBkUp;
	short	ioVAtrb;
	short	ioVNmFls;
	short	ioVDirSt;
	short	ioVBlLn;
	short	ioVNmAlBlks;
	long	ioVAlBlkSiz;
	long	ioVClpSiz;
	short	ioAlBlSt;
	long	ioVNextFNum;
	short	ioVFrBlk;
};

struct drvQElRec {
	struct drvQElRec *		drvLink;
	short					drvFlags;
	short					drvRefNum;
	short					drvFSID;
	short					drvBlkSize;
};

union OpParamType {
	struct {
		short					sg_flags;
		char					sg_erase;
		char					sg_kill;
	} conCtl;
	short	sndVal;
	short	asncConfig;
	struct {
		Ptr	asncBPtr;
		short	asncBLen;
	} asyncInBuff;
	struct {
		unsigned char	fXOn;
		unsigned char	fCTS;
		char			xon;
		char			xoff;
		unsigned char	errs;
		unsigned char	evts;
		unsigned char	fInX;
		unsigned char	null;
	} asyncShk;
	struct {
		long	param1;
		long	param2;
		long	param3;
	} printer;
	struct {
		Ptr		fontRecPtr;
		short	fontCurDev;
	} fontMgr;
	Ptr		diskBuff;
	long	asyncNBytes;
	struct {
		short	asncS1;
		short	asncS2;
		short	asncS3;
	} asyncStatus;
	struct {
		short					dskTrackLock;
		long					dskInfoBits;
		struct drvQElRec		dskQElem;
		short					dskPrime;
		short					dskErrCnt;
	} diskStat;
};
typedef union OpParamType		OpParamType;
typedef union OpParamType *		OpParamPtr;

struct cntrlParam {
	short			csRefNum;
	short			csCode;
	OpParamType		csParam;
};

struct ParamBlkRec {
	struct ParamBlkRec *	ioLink;
	short					ioType;
	short					ioTrap;
	Ptr						ioCmdAddr;
	ProcPtr					ioCompletion;
	short					ioResult;
	char *					ioNamePtr;
	short					ioVRefNum;
	union {
		struct ioParam iop;
		struct fileParam fp;
		struct volumeParam vp;
		struct cntrlParam cp;
	} u;
};
typedef struct ParamBlkRec		ParamBlkRec;
typedef struct ParamBlkRec *	ParmBlkPtr;


	   void		AddDrive();
	   OSErr	OpenDriver();
	   OSErr	CloseDriver();
	   OSErr	FSOpen();
	   OSErr	FSClose();
	   OSErr	FSRead();
	   OSErr	FSWrite();
	   OSErr	Control();
	   OSErr	Status();
	   OSErr	KillIO();
	   OSErr	GetVInfo();
	   OSErr	GetFInfo();
	   OSErr	GetVol();
	   OSErr	SetVol();
	   OSErr	UnmountVol();
	   OSErr	Eject();
	   OSErr	FlushVol();
	   OSErr	Create();
	   OSErr	FSDelete();
	   OSErr	OpenRF();
	   OSErr	SetFInfo();
	   OSErr	SetFLock();
	   OSErr	RstFLock();
	   OSErr	SetFType();
	   OSErr	Allocate();
	   OSErr	GetEOF();
	   OSErr	SetEOF();
	   OSErr	GetFPos();
	   OSErr	SetFPos();
	   OSErr	FlushFile();
	   OSErr	Rename();
pascal void		InitQueue();
	   QHdrPtr	GetDrvQHdr();
	   QHdrPtr	GetFSQHdr();
	   QHdrPtr	GetVCBQHdr();
pascal OSErr	PBMountVol();
pascal OSErr	PBGetVInfo();
pascal OSErr	PBGetVol();
pascal OSErr	PBSetVol();
pascal OSErr	PBFlushVol();
pascal OSErr	PBUnmountVol();
pascal OSErr	PBOffLine();
pascal OSErr	PBEject();
pascal OSErr	PBCreate();
pascal OSErr	PBOpen();
pascal OSErr	PBOpenRF();
pascal OSErr	PBRead();
pascal OSErr	PBWrite();
pascal OSErr	PBGetFPos();
pascal OSErr	PBSetFPos();
pascal OSErr	PBGetEOF();
pascal OSErr	PBSetEOF();
pascal OSErr	PBAllocate();
pascal OSErr	PBFlushFile();
pascal OSErr	PBClose();
pascal OSErr	PBGetFInfo();
pascal OSErr	PBSetFInfo();
pascal OSErr	PBSetFLock();
pascal OSErr	PBRstFLock();
pascal OSErr	PBSetFVers();
pascal OSErr	PBRename();
pascal OSErr	PBDelete();
pascal OSErr	PBControl();
pascal OSErr	PBStatus();
pascal OSErr	PBKillIO();

/* include/print */
#define	bDraftLoop		0
#define	bSpoolLoop		1
#define	bUser1Loop		2
#define	bUser2Loop		3

#define	iPrBitsCtl		4
#define	lScreenBits		0
#define	lPaintBits		1
#define	iPrIOCtl		5
#define	iPrEvtCtl		6
#define	iPrEvtAll		0x0002fffd
#define	iPrEvtTop		0x0001fffd
#define	iPrDevCtl		7
#define	lPrReset		0x00010000
#define	lPrPageEnd		0x00020000
#define	lPrLineFeed		0x00030000
#define	iFMgrCtl		8

#define	iPFMaxPgs		128
#define	iPrPgFract		120
#define	iPrAbort		128
#define	iPrRelease		2
#define	lPfType			'PFIL'
#define	lPfSig			'PSYS'

#define	sPrDrvr			"\P.Print"
#define	iPrDrvrRef		(-3)
#define	lPrintType		'PREC'
#define	iPrintDef		0
#define	iPrintLst		1
#define	iPrintDrvr		2
#define	iMyPrDrvr		0xe000
#define	iPStrRFil		0xe000
#define	iPStrPFil		0xe001
#define	iPrStlDlg		0xe000
#define	iPrJobDlg		0xe001

typedef char				TStr80[81];
typedef TStr80 *			TPStr80;

typedef Rect *				TPRect;

struct TPrPort {
	GrafPort	gPort;
	QDProcs		gProcs;
	long		lGParam1;
	long		lGParam2;
	long		lGParam3;
	long		lGParam4;
	Boolean		fOurPtr;
	Boolean		fOurBits;
};
typedef struct TPrPort		TPrPort;
typedef struct TPrPort *	TPPrPort;

union TPPort {
	GrafPtr		pGPort;
	TPPrPort	pPrPort;
};
typedef union TPPort		TPPort;

struct TPrInfo {
	short		iDev;
	short		iVRes;
	short		iHRes;
	Rect		rPage;
};
typedef struct TPrInfo		TPrInfo;

typedef unsigned char		TFeed;

#define	feedCut		0
#define	feedFanfold	1
#define	feedMechCut	2
#define	feedOther	3

typedef short				TWord;

struct TPrStl {
	TWord		wDev;
	short		iPageV;
	short		iPageH;
	SignedByte	bPort;
	TFeed		feed;
};
typedef struct TPrStl		TPrStl;

struct TPrJob {
	short		iFstPage;
	short		iLstPage;
	short		iCopies;
	SignedByte	bJDocLoop;
	Boolean		fFromUsr;
	ProcPtr		pIdleProc;
	TPStr80		pFileName;
	short		iFileVol;
	SignedByte	bFileVers;
	SignedByte	bJobX;
};
typedef struct TPrJob		TPrJob;

typedef unsigned char		TScan;

#define	scanTB	0
#define	scanBT	1
#define	scanLR	2
#define	scanRL	3

struct TPrXInfo {
	short		iRowBytes;
	short		iBandV;
	short		iBandH;
	short		iDevBytes;
	short		iBands;
	SignedByte	bPatScale;
	SignedByte	bUlThick;
	SignedByte	bUlOffset;
	SignedByte	bUlShadow;
	TScan		scan;
	SignedByte	bXInfoX;
};
typedef struct TPrXInfo		TPrXInfo;

struct TPrint {
	short		iPrVersion;
	TPrInfo		prInfo;
	Rect		rPaper;
	TPrStl		prStl;
	TPrInfo		prInfoPt;
	TPrXInfo	prXInfo;
	TPrJob		prJob;
	short		printX[19];
};
typedef struct TPrint		TPrint;
typedef struct TPrint *		TPPrint;
typedef struct TPrint **	THPrint;

struct TPrStatus {
	short		iTotPages;
	short		iCurPage;
	short		iTotCopies;
	short		iCurCopy;
	short		iTotBands;
	short		iCurBand;
	Boolean		fPgDirty;
	Boolean		fImaging;
	THPrint		hPrint;
	TPPrPort	pPrPort;
	PicHandle	hPic;
};
typedef struct TPrStatus	TPrStatus;

pascal void			PrOpen();
pascal void			PrClose();
pascal void			PrintDefault();
pascal Boolean		PrValidate();
pascal Boolean		PrStlDialog();
pascal Boolean		PrJobDialog();
pascal void			PrJobMerge();
pascal TPPrPort		PrOpenDoc();
pascal void			PrCloseDoc();
pascal void			PrOpenPage();
pascal void			PrClosePage();
pascal void			PrPicFile();
pascal short		PrError();
pascal void			PrSetError();
pascal void			PrDrvrOpen();
pascal void			PrDrvrClose();
pascal void			PrCtlCall();
pascal Handle		PrDrvrDCE();
pascal short		PrDrvrVers();
pascal void			PrNoPurge();
pascal void			PrPurge();

/* include/resource */
#define	resSysRef		0x80
#define	resSysHeap		0x40
#define	resPurgeable	0x20
#define	resLocked		0x10
#define	resProtected	0x08
#define	resPreload		0x04
#define	resChanged		0x02
#define	resUser			0x01

#define	mapReadOnly		0x80
#define	mapCompact		0x40
#define	mapChanged		0x20

typedef long ResType;

pascal short			InitResources()			=	0xa995;
pascal void				RsrcZoneInit()			=	0xa996;
pascal void				CreateResFile()			=	0xa9b1;
pascal short			OpenResFile()			=	0xa997;
pascal void				CloseResFile()			=	0xa99a;
pascal short			ResError()				=	0xa9af;
pascal short			CurResFile()			=	0xa994;
pascal short			HomeResFile()			=	0xa9a4;
pascal void				UseResFile()			=	0xa998;
pascal short			CountTypes()			=	0xa99e;
pascal void				GetIndType()			=	0xa99f;
pascal void				SetResLoad()			=	0xa99b;
pascal short			CountResources()		=	0xa99c;
pascal Handle			GetIndResource()		=	0xa99d;
pascal Handle			GetResource()			=	0xa9a0;
pascal Handle			GetNamedResource()		=	0xa9a1;
pascal void				LoadResource()			=	0xa9a2;
pascal void				ReleaseResource()		=	0xa9a3;
pascal void				DetachResource()		=	0xa992;
pascal short			UniqueID()				=	0xa9c1;
pascal void				GetResInfo()			=	0xa9a8;
pascal short			GetResAttrs()			=	0xa9a6;
pascal void				SetResInfo()			=	0xa9a9;
pascal void				SetResAttrs()			=	0xa9a7;
pascal void				ChangedResource()		=	0xa9aa;
pascal void				AddResource()			=	0xa9ab;
pascal void				RmveResource()			=	0xa9ad;
pascal void				AddReference()			=	0xa9ac;
pascal void				RmveReference()			=	0xa9ae;
pascal void				UpdateResFile()			=	0xa999;
pascal void				WriteResource()			=	0xa9b0;
pascal void				SetResPurge()			=	0xa993;
pascal short			GetResFileAttrs()		=	0xa9f6;
pascal void				SetResFileAttrs()		=	0xa9f7;
pascal long				SizeResource()			=	0xa9a5;

/* include/retrace */
typedef struct {
	QElemPtr	*qLink;
	short		qType;
	ProcPtr		vblAddr;
	short		vblCount;
	short		vblPhase;
} VBLTask;

	   OSErr	VInstall();
	   OSErr	VRemove();
	   QHdrPtr	GetVBLQHdr();
	   
/* include/scrap */
struct ScrapStuff {
	long		scrapSize;
	Handle		scrapHandle;
	short		scrapCount;
	short		scrapState;
	StringPtr	scrapName;
};
typedef struct ScrapStuff		ScrapStuff;
typedef struct ScrapStuff *		PScrapStuff;

pascal PScrapStuff			InfoScrap()			=	0xa9f9;
pascal long					UnloadScrap()		=	0xa9fa;
pascal long					LoadScrap()			=	0xa9fb;
pascal long					GetScrap()			=	0xa9fd;
pascal long					ZeroScrap()			=	0xa9fc;
pascal long					PutScrap()			=	0xa9fe;

/* include/segment */

#define	appOpen		0
#define appPrint	1

struct AppFile {
	short	vRefNum;
	OSType	fType;
	short	versNum;
	Str255	fName;
};
typedef struct AppFile		AppFile;

pascal void		LoadSeg()		=	0xa9f0;
pascal void		UnloadSeg()		=	0xa9f1;
pascal void		ExitToShell()	=	0xa9f4;
pascal void		GetAppParms()	=	0xa9f5;
	   void		Launch();
	   void		Chain();
	   void		CountAppFiles();
	   void		GetAppFiles();
	   void		ClrAppFiles();

/* include/serial */

#define	baud300		380
#define	baud600		189
#define	baud1200	94
#define	baud1800	62
#define	baud2400	46
#define	baud3600	30
#define	baud4800	22
#define	baud7200	14
#define	baud9600	10
#define	baud19200	4
#define	baud57600	0

#define	stop10		0x4000
#define	stop15		0x8000
#define	stop20		0xc000

#define	noParity	0x2000
#define	oddParity	0x1000
#define	evenParity	0x3000

#define	data5		0x0000
#define	data6		0x0800
#define	data7		0x0400
#define	data8		0x0c00

#define	swOverrunErr	0x01
#define	parityErr		0x10
#define	hwOverrunErr	0x20
#define framingErr		0x40

#define	ctsEvent		0x20
#define	breakEvent		0x80

#define	xOffWasSent		0x80

#define	sPortA		0x000
#define	sPortB		0x100

typedef struct {
	char			fXOn;
	char			fCTS;
	unsigned char	xOn;
	unsigned char	xOff;
	char			errs;
	char			evts;
	char			fInX;
	char			null;
} SerShk;

typedef struct {
	char			cumErrs;
	char			xOffSent;
	char			rdPend;
	char			wrPend;
	char			ctsHold;
	char			xOffHold;
} SerStaRec;

	   OSErr		RamSDOpen();
	   void			RamSDClose();
	   OSErr		SerReset();
	   OSErr		SerSetBuf();
	   OSErr		SerHShake();
	   OSErr		SerSetBrk();
	   OSErr		SerClrBrk();
	   OSErr		SerGetBuf();
	   OSErr		SerErrFlg();
	   
/* include/setjmp */
#define	JBUFSIZE	9
typedef long jmp_buf[JBUFSIZE];

/* include/sgtty */
#define TIOCGETP	0		/* read contents of tty control structure */
#define TIOCSETP	1		/* set contents of tty control structure */
#define TIOCSETN	2		/* ditto only don't wait for output to flush */

struct sgttyb {
	short sg_flags;		/* control flags */
	char sg_erase;
	char sg_kill;
};

/* settings for flags */
#define	TABSIZ	0x000f	/* size of tab if XTABS is set */
#define	XTABS	0x0010	/* convert tabs to spaces on output */
#define	CRMOD	0x0020	/* CR -> LF on input, LF -> CR/LF on output */
#define	ECHO	0x0040	/* echo input to output */
#define	ECHOE	0x0080	/* follow erase character by space, BS */
#define	CBREAK	0x0100	/* don't wait for the whole line */
#define	NODELAY	0x0200	/* return even if no characters */
#define RAW		0x0400	/* no input or output mapping at all */
#define	CHKKEY	0x0800	/* check for keyboard characters during output */
#define	ERASE	0x1000	/* erase character space before drawing */

/* include/sound */
#define	swMode	-1
#define	ftMode	1
#define	ffMode	0

typedef char	FreeWave[30001];

typedef struct {
	short		mode;
	Fixed		count;
	FreeWave	waveBytes;
} FFSynthRec, *FFSynthPtr;

typedef struct {
	short		count;
	short		amplitude;
	short		duration;
} Tone, Tones[5001];

typedef struct {
	short		mode;
	Tones		triplets;
} SWSynthRec, *SWSynthPtr;

typedef char	Wave[256];
typedef Wave *	WavePtr;

typedef struct {
	short		duration;
	Fixed		sound1Rate;
	long		sound1Phase;
	Fixed		sound2Rate;
	long		sound2Phase;
	Fixed		sound3Rate;
	long		sound3Phase;
	Fixed		sound4Rate;
	long		sound4Phase;
	WavePtr		sound1Wave;
	WavePtr		sound2Wave;
	WavePtr		sound3Wave;
	WavePtr		sound4Wave;
} FTSoundRec, *FTSndRecPtr;

typedef struct {
	short		mode;
	FTSndRecPtr	sndRec;
} FTSynthRec, *FTSynthPtr;

	   void		StartSound();
	   void		StopSound();
	   Boolean	SoundDone();
	   void		GetSoundVol();
	   void		SetSoundVol();

/* include/stdio */
#define fgetc getc
#define fputc putc
#define NULL (0L)
#define EOF (-1)

#define BUFSIZ 1024
#define MAXSTREAM	11

#define _BUSY	0x01
#define _ALLBUF	0x02
#define _DIRTY	0x04
#define _EOF	0x08
#define _IOERR	0x10

typedef struct {
	char *_bp;			/* current position in buffer */
	char *_bend;		/* last character in buffer + 1 */
	char *_buff;		/* address of buffer */
	char _flags;		/* open mode, etc. */
	char _unit;			/* token returned by open */
	char _bytbuf;		/* single byte buffer for unbuffer streams */
	int	_buflen;		/* length of buffer */
} FILE;

extern FILE Cbuffs[];
FILE *fopen();
long ftell();

#define stdin (&Cbuffs[0])
#define stdout (&Cbuffs[1])
#define stderr (&Cbuffs[2])
#define getchar() agetc(stdin)
#define putchar(c) aputc(c, stdout)
#define feof(fp) (((fp)->_flags&_EOF)!=0)
#define ferror(fp) (((fp)->_flags&_IOERR)!=0)
#define clearerr(fp) ((fp)->_flags &= ~(_IOERR|_EOF))
#define fileno(fp) ((fp)->_unit)
#define fflush(fp) flsh_(fp,-1)

/* include/syserr */
/* Macintosh OS system errors	*/

#define	noErr	0       /* All is well */

		/* file system error codes */

#define	qErr			(-1)
#define	vTypErr			(-2)

#define	dirFulErr		(-33)	/* Directory full */
#define	dskFulErr		(-34)	/* disk full */
#define	nsvErr			(-35)	/* no such volume */
#define	ioErr			(-36)	/* I/O error (bummers) */
#define	bdNamErr		(-37)	/* there may be no bad names in the final system! */
#define	fnOpnErr		(-38)	/* File not open */
#define	eofErr			(-39)	/* End of file */
#define	posErr			(-40)	/* tried to position to before start of file */
#define	mFulErr			(-41)	/* memory full(open) or file won't fit (load) */
#define	tmfoErr			(-42)	/* too many files open */
#define	fnfErr			(-43)	/* File not found */

#define	wPrErr			(-44)	/* diskette is write protected */
#define	fLckdErr		(-45)	/* file is locked */
#define	vLckdErr		(-46)	/* volume is locked */
#define	fBsyErr			(-47)	/* File is busy (delete) */
#define	dupFNErr		(-48)	/* duplicate filename (rename) */
#define	opWrErr			(-49)	/* file already open with with write permission */
#define	paramErr		(-50)	/* error in user parameter list */
#define	rfNumErr		(-51)	/* refnum error */
#define	gfpErr			(-52)	/* get file position error */
#define	volOffLinErr	(-53)	/* volume not on line error (was Ejected) */
#define	permErr			(-54)	/* permissions error (on file open) */
#define	volOnLinErr		(-55)	/* drive volume already on- ine at MountVol */
#define	nsDrvErr		(-56)	/* no such drive (tried to mount a bad drive #) */
#define	noMacDskErr		(-57)	/* not a mac diskette (sig bytes are wrong) */
#define	extFSErr		(-58)	/* volume in question belongs to an external fs */
#define	fsRnErr			(-59)	/* Problem during rename */
#define	badMDBErr		(-60)	/* bad master directory block */
#define	wrPermErr		(-61)	/* write permissions error */

#define	clkRdErr		(-85)
#define clkWrErr		(-86)
#define prWrErr			(-87)
#define prInitErr		(-88)

#define noScrapErr		(-100)
#define noTypeErr		(-102)


#define	memFullErr		(-108)	/* Not enough room in heap zone */
#define	nilHandleErr	(-109)	/* Master Pointer was NIL in HandleZone */
#define	memWZErr		(-111)	/* WhichZone failed (applied to free block) */
#define	memPurErr		(-112)	/* trying to purge a locked or
														non-purgeable block */

#define	resNotFound		(-192)
#define	resFNotFound	(-193)
#define	addResFailed	(-194)
#define	addRefFailed	(-195)
#define	rmvResFailed	(-196)
#define	rmvRefFailed	(-197)
























